// generated by Fast Light User Interface Designer (fluid) version 1.0106

#include "win_main.h"
#include <Fl/fl_ask.h>
#include <FL/Fl_File_Chooser.H>
#include <stdio.h>
#include "action.h"
#include "file.h"
#include "tool.h"
#include "ui_tools.h"
#include "win_about.h"
#include "win_browser.h"
#include "win_info.h"
#include "win_open.h"
#include "win_stuff.h"

inline void MainWindow::cb_New_i(Fl_Menu_*, void*) {
  add_image();
workspace->redraw();
setup_view_menu();
}
void MainWindow::cb_New(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_New_i(o,v);
}

inline void MainWindow::cb_Open_i(Fl_Menu_*, void*) {
#if 1
	char *fname;
	char *errmsg;
	//char *fl_file_chooser(const char * message, const char *pattern, const char *fname, int relative = 0);
	fname=fl_file_chooser("Open file ...", "*", 0);
	Canvas *c=File::open(fname,"*",&errmsg);
	if(c==0)
	{	ask("Error while opening file",0,errmsg,"OK");
		return;
	}
	add(c);
#else
  Win_Open open_win(&dir,"Open file ...");
if(!open_win.run()) return;
for(int i=0;;){
  const char *fname=open_win.file(i);
  char *errmsg;
  if(fname==0) break;
  Canvas *c=File::open(fname,open_win.extension(),&errmsg);
  if(c!=0) add(c);
  if(c==0)
    ask("Error while opening file",0,errmsg,"OK");

}

setup_view_menu();

setup_view_menu();
#endif
}
void MainWindow::cb_Open(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_Open_i(o,v);
}

inline void MainWindow::cb_Browse_i(Fl_Menu_*, void*) {
  Win_Browser browser(&dir);
if(!browser.run()) return;
for(int i=0;;){
  const char *fname=browser.file(i);
  char *errmsg;
  if(fname==0) break;
  Canvas *c=File::open(fname,"*",&errmsg);
  if(c!=0) add(c);
  if(c==0) fl_alert(errmsg);
}
setup_view_menu();
}
void MainWindow::cb_Browse(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_Browse_i(o,v);
}

inline void MainWindow::cb_Save_i(Fl_Menu_*, void*) {
  if(selected()==0) return;
const char *name=selected()->param("File");
if(name==0){
 ask("No filename !",0,"Can't save.  File has no name","OK");
 return;
}
File::save(selected(),name,0);
selected()->saveme(false);
}
void MainWindow::cb_Save(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

inline void MainWindow::cb_Save1_i(Fl_Menu_*, void*) {
  if(selected()==0) return;
Win_Open open_win(&dir,"Save file as ...","Save");
if(!open_win.run()) return;
int n=0;
const char *fname=open_win.file(n);
File::save(selected(),fname,open_win.extension());
selected()->saveme(false);
}
void MainWindow::cb_Save1(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_Save1_i(o,v);
}

inline void MainWindow::cb_Close_i(Fl_Menu_*, void*) {
  if(selected()==0) return;
close_file();
}
void MainWindow::cb_Close(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

inline void MainWindow::cb_Info_i(Fl_Menu_*, void*) {
  if(selected()==0) return;
Win_Info w(selected());
w.run();
}
void MainWindow::cb_Info(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_Info_i(o,v);
}

inline void MainWindow::cb_undo_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	workspace->canvas()->undo_action();
workspace->redraw();
}
void MainWindow::cb_undo(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_undo_i(o,v);
}

inline void MainWindow::cb_resize_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_resize(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_resize(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_resize_i(o,v);
}

inline void MainWindow::cb_mirror_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_mirror_lr(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_mirror(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_mirror_i(o,v);
}

inline void MainWindow::cb_mirror1_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_mirror_ud(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_mirror1(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_mirror1_i(o,v);
}

inline void MainWindow::cb_mirror2_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_mirror_diag(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_mirror2(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_mirror2_i(o,v);
}

inline void MainWindow::cb_rotate_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_rotate_90(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_rotate(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_rotate_i(o,v);
}

inline void MainWindow::cb_rotate1_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_rotate_270(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_rotate1(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_rotate1_i(o,v);
}

inline void MainWindow::cb_rotate2_i(Fl_Menu_*, void*) {
  if(workspace->canvas()!=0)
	action_rotate_180(workspace->canvas());
workspace->redraw();
}
void MainWindow::cb_rotate2(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_rotate2_i(o,v);
}

inline void MainWindow::cb_roll_i(Fl_Menu_*, void*) {
  workspace->tool(new ToolRoll());
toolhider->setonly();
}
void MainWindow::cb_roll(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_roll_i(o,v);
}

Fl_Menu_Item MainWindow::menu_menubar[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 14, 56},
 {"&New", 0x4006e,  (Fl_Callback*)MainWindow::cb_New, 0, 0, 0, 0, 14, 56},
 {"&Open", 0x4006f,  (Fl_Callback*)MainWindow::cb_Open, 0, 0, 0, 0, 14, 56},
 {"&Browse", 0x4006f,  (Fl_Callback*)MainWindow::cb_Browse, 0, 0, 0, 0, 14, 56},
 {"&Save", 0x40073,  (Fl_Callback*)MainWindow::cb_Save, 0, 0, 0, 0, 14, 56},
 {"&Save as", 0,  (Fl_Callback*)MainWindow::cb_Save1, 0, 0, 0, 0, 14, 56},
 {"&Close", 0,  (Fl_Callback*)MainWindow::cb_Close, 0, 128, 0, 0, 14, 56},
 {"&Info", 0x40069,  (Fl_Callback*)MainWindow::cb_Info, 0, 128, 0, 0, 14, 56},
 {"&Exit", 0x8ffc1,  (Fl_Callback*)run_modal_callback, 0, 0, 0, 0, 14, 56},
 {0,0,0,0,0,0,0,0,0},
 {"&Edit", 0,  0, 0, 192, 0, 0, 14, 56},
 {"Undo last", 0x4007a,  (Fl_Callback*)MainWindow::cb_undo, 0, 0, 0, 0, 14, 56},
 {"C&ut", 0,  0, 0, 1, 0, 0, 14, 56},
 {"C&opy", 0,  0, 0, 1, 0, 0, 14, 56},
 {"&Paste", 0,  0, 0, 129, 0, 0, 14, 56},
 {"resize", 0x40072,  (Fl_Callback*)MainWindow::cb_resize, 0, 0, 0, 0, 14, 56},
 {"mirror l/r", 0,  (Fl_Callback*)MainWindow::cb_mirror, 0, 0, 0, 0, 14, 56},
 {"mirror u/d", 0,  (Fl_Callback*)MainWindow::cb_mirror1, 0, 0, 0, 0, 14, 56},
 {"mirror diag", 0,  (Fl_Callback*)MainWindow::cb_mirror2, 0, 0, 0, 0, 14, 56},
 {"rotate left", 0,  (Fl_Callback*)MainWindow::cb_rotate, 0, 0, 0, 0, 14, 56},
 {"rotate right", 0,  (Fl_Callback*)MainWindow::cb_rotate1, 0, 0, 0, 0, 14, 56},
 {"rotate 180\260", 0,  (Fl_Callback*)MainWindow::cb_rotate2, 0, 0, 0, 0, 14, 56},
 {"roll", 0,  (Fl_Callback*)MainWindow::cb_roll, 0, 0, 0, 0, 14, 56},
 {0,0,0,0,0,0,0,0,0},
 {"&Views", 0,  0, 0, 0, 0, 0, 14, 56},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* MainWindow::menu_first = MainWindow::menu_menubar + 0;
Fl_Menu_Item* MainWindow::menu_exit = MainWindow::menu_menubar + 8;
Fl_Menu_Item* MainWindow::undo = MainWindow::menu_menubar + 11;
Fl_Menu_Item* MainWindow::views = MainWindow::menu_menubar + 24;

inline void MainWindow::cb_About_i(Fl_Menu_*, void*) {
  Win_About w;
w.run();
}
void MainWindow::cb_About(Fl_Menu_* o, void* v) {
  ((MainWindow*)(o->parent()->user_data()))->cb_About_i(o,v);
}

Fl_Menu_Item MainWindow::menu_[] = {
 {"Info", 0,  0, 0, 64, 0, 0, 14, 56},
 {"About", 0,  (Fl_Callback*)MainWindow::cb_About, 0, 0, 0, 0, 14, 56},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};

inline void MainWindow::cb__i(Fl_Button*, void*) {
  workspace->tool(new ToolDot());
}
void MainWindow::cb_(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb__i(o,v);
}

#include <FL/Fl_Pixmap.H>
static const char *idata_pen[] = {
"24 24 5 1",
"  c None",
"! c #000000",
"~ c #4444c1",
"# c #000073",
"$ c #ffa900",
"                !       ",
"               !~!      ",
"              !~~~!     ",
"             !~~~!#!    ",
"            !~~~!###!   ",
"           !~~~!###!~!  ",
"          !~~~!###!~~~! ",
"         !~~~!###!~~~!  ",
"        !~~~!###!~~~!   ",
"       !~~~!###!~~~!    ",
"      !~~~!###!~~~!     ",
"     !~~~!###!~~~!      ",
"    !~~~!###!~~~!       ",
"   !~~~!###!~~~!        ",
"   !!~!###!~~~!         ",
"   !$!###!~~~!          ",
"   !$$!#!~~~!           ",
"   !$$$!~~~!            ",
"   !!$$$!~!             ",
"   !!!!!!!              ",
"                        ",
"                        ",
"                        ",
"                        "
};
static Fl_Pixmap image_pen(idata_pen);

inline void MainWindow::cb_1_i(Fl_Button*, void*) {
  workspace->tool(new ToolLine());
}
void MainWindow::cb_1(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb_1_i(o,v);
}

static const char *idata_tool_line[] = {
"24 24 21 1",
"  c None",
"! c #000000",
"~ c #ffffff",
"# c #fdfdff",
"$ c #ff0000",
"% c #fbfbff",
"& c #fafaff",
"\' c #f8f8ff",
"( c #f7f7ff",
") c #f5f5ff",
"* c #f3f3ff",
"+ c #f2f2ff",
", c #f0f0ff",
"- c #efefff",
". c #ededff",
"/ c #ececff",
"0 c #eaeaff",
"1 c #e8e8ff",
"2 c #00ff00",
"3 c #e7e7ff",
"4 c #e5e5ff",
"          !~####~~~~~~!~",
"         !##~#~########!",
"        !~$%%%#%%%%%!%! ",
"       !~~~$&&&&&&&&&!  ",
"      !\'$~$\'$\'\'\'\'\'!\'!   ",
"     !((($(((((!(((!    ",
"    !)))))$)))))!)!     ",
"   !*************!      ",
"  !++!!+++++++!+!       ",
" !,,!  !,,,,,,,!        ",
"!---!  !----!-!         ",
" !...!!......!          ",
"  !///////!/!           ",
"   !000!000!            ",
"    !111!1!           22",
"     !333!        2222  ",
"      !4!     2222      ",
"       !  2222          ",
"      2222              ",
"  2222                  ",
"22                      ",
"                        ",
"                        ",
"                        "
};
static Fl_Pixmap image_tool_line(idata_tool_line);

inline void MainWindow::cb_2_i(Fl_Button*, void*) {
  workspace->tool(new ToolRect());
}
void MainWindow::cb_2(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb_2_i(o,v);
}

static const char *idata_tool_rect[] = {
"24 24 4 1",
"  c None",
"! c #b0b13d",
"~ c #e7e800",
"# c #000000",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   !~!                  ",
"   ###                  ",
"   #~#                  ",
" ###~###!!!!!!!!!!!!!!!!",
" # !~~~#~~~~~~~~~~~~~~~~",
" ###!###!!!!!!!!!!!!!!!!",
"   # #                  ",
"   ###                  ",
"                        ",
"                        "
};
static Fl_Pixmap image_tool_rect(idata_tool_rect);

inline void MainWindow::cb_3_i(Fl_Button*, void*) {
  workspace->tool(new ToolCircle());
}
void MainWindow::cb_3(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb_3_i(o,v);
}

static const char *idata_tool_circle[] = {
"24 24 4 1",
"  c None",
"! c #004a00",
"~ c #007f00",
"# c #00ff00",
"                        ",
"                        ",
"  !~~~~~!               ",
" !~#####~~!             ",
" ~#~~~~~##~~!           ",
" ~#~   !~~##~!          ",
" ~#~     !~~#~!         ",
" ~#~       !~#~!        ",
" ~#~        !~#~!       ",
" ~#~!        !~#~!      ",
" !~#~!        !~#~!     ",
"  !~#~         !~#~!    ",
"   ~#~!         !~#~    ",
"   !~#~!         ~#~!   ",
"    !~#~!        !~#~!  ",
"     !~#~!        !~#~  ",
"      !~#~!        ~#~  ",
"       !~#~!       ~#~  ",
"        !~#~~!     ~#~  ",
"         !~##~~!   ~#~  ",
"          !~~##~~~~~#~  ",
"            !~~#####~!  ",
"              !~~~~~!   ",
"                        "
};
static Fl_Pixmap image_tool_circle(idata_tool_circle);

inline void MainWindow::cb_4_i(Fl_Button*, void*) {
  workspace->tool(new ToolFill());
}
void MainWindow::cb_4(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb_4_i(o,v);
}

static const char *idata_tool_fill[] = {
"24 24 4 1",
"  c None",
"! c #000000",
"~ c #920000",
"# c #ffffff",
"                        ",
"                        ",
"               !!!      ",
"              !  !      ",
"             !~! !      ",
"            !~~~!       ",
"           !~~~!!!      ",
"          !~~~!!!~!     ",
"         !~~~!!!~~~!    ",
"        !~~~!!!~~~~~!   ",
"       #!!~!!!~~~~~~~!  ",
"       #  !!!~~~~~~~~~! ",
"       #   !~~~~~~~~~~~!",
"       #    !~~~~~~~~~! ",
"       #     !~~~~~~~!  ",
"       #      !~~~~~!   ",
"       #       !~~~!    ",
"       #        !~!     ",
"     ####        !      ",
"   ########             ",
"  ##########            ",
"  #########             ",
"   #######              ",
"                        "
};
static Fl_Pixmap image_tool_fill(idata_tool_fill);

inline void MainWindow::cb_5_i(Fl_Button*, void*) {
  workspace->tool(new ToolFRect());
}
void MainWindow::cb_5(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb_5_i(o,v);
}

static const char *idata_tool_frect[] = {
"24 24 7 1",
"  c None",
"! c #c6c7c7",
"~ c #84d984",
"# c #42ec42",
"$ c #00b600",
"% c #000000",
"& c #2cee2c",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~#$$$$$$$$$$$$$$$$$$$",
"!!!~%%%$$$$$$$$$$$$$$$$$",
"!!!~%$%$$$$$$$$$$$$$$$$$",
"!!%%%$%%%$$$$$$$$$$$$$$$",
"!!%~#$$$%$$$$$$$$$$$$$$$",
"!!%%%&%%%&&&&&&&&&&&&&&&",
"!!!~%~%~~~~~~~~~~~~~~~~~",
"!!!!%%%!!!!!!!!!!!!!!!!!",
"!!!!!!!!!!!!!!!!!!!!!!!!",
"!!!!!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap image_tool_frect(idata_tool_frect);

inline void MainWindow::cb_6_i(Fl_Button*, void*) {
  workspace->tool(new ToolFCircle());
}
void MainWindow::cb_6(Fl_Button* o, void* v) {
  ((MainWindow*)(o->parent()->parent()->user_data()))->cb_6_i(o,v);
}

static const char *idata_tool_fcircle[] = {
"24 24 7 1",
"  c None",
"! c #003700",
"~ c #004a00",
"# c #007500",
"$ c #009400",
"% c #00de00",
"& c #000c00",
"   !~~~!                ",
"  !#$$$#~~!             ",
" !#$%%%$$$#!            ",
" ~$%%%%%%%$#~!          ",
"!#%%%%%%%%%$$#!         ",
"~$%%%%%%%%%%%$#!        ",
"~$%%%%%%%%%%%%$#!       ",
"!#%%%%%%%%%%%%%$#!      ",
" ~$%%%%%%%%%%%%%$#!     ",
" ~$%%%%%%%%%%%%%%$#!    ",
" !#%%%%%%%%%%%%%%%$~    ",
"  !#%%%%%%%%%%%%%%$#!   ",
"   ~$%%%%%%%%%%%%%%$#!  ",
"   !#$%%%%%%%%%%%%%%$~  ",
"    !#%%%%%%%%%%%%%%$~& ",
"     !#%%%%%%%%%%%%%$#! ",
"      !#$%%%%%%%%%%%%$~ ",
"       !#$%%%%%%%%%%%$~ ",
"        !#$%%%%%%%%%$#! ",
"         !~#$%%%%%%%$~& ",
"           !#$$$%%%$#!  ",
"            !~~#$$$#!&  ",
"               !~~~!&   ",
"                        "
};
static Fl_Pixmap image_tool_fcircle(idata_tool_fcircle);

void MainWindow::setscale(Fl_Widget *w,int scale) {
  //Menuitem sets scale

MainWindow *me=(MainWindow *)(w->window()->user_data());
me->workspace->drawscale(scale);
me->workspace->redraw();
}

void MainWindow::select_image_cb(Fl_Widget *widget,void *arg) {
  //bring image to front
int index=int(arg);
MainWindow *me=(MainWindow *)(widget->window()->user_data());
me->MainBase::select_image(index);
me->workspace->canvas(me->selected());
me->workspace->redraw();
}

void MainWindow::setup_view_menu() {
  //setup view menu
generate_view_menu(menubar,views-menu_first,
	select_image_cb);
}

bool MainWindow::close_file() {
  //Close selected(), select something else.  return false if user changes his mind
if(selected()->saveme()){
	char *s=msprintf("Image '%s' has been changed\nWhat should i do ?",
	selected()->paramdefault("File","(Unnamed)"));
	int answer=ask("Image was changed",0,s,"Save && Close","Close","Cancel");
	free(s);
	if(answer!=0&&answer!=1)
		return false;

	//Save if we want it.
	if(answer==0){
		const char *fname=selected()->param("File");
		if(fname==0){
			Win_Open open_win(&dir,"Save file as ...","Save");
			if(!open_win.run()) return false;
			int n=0;
			fname=open_win.file(n);
			File::save(selected(),fname,open_win.extension());
		}else
			File::save(selected(),fname,"*");
		selected()->saveme(false); //Kind of stupid now, but ...
	}
}
//Close window
remove(selected());
setup_view_menu();
workspace->canvas(selected());
workspace->redraw();
return true;
}

const int main_width=700;//600
const int main_height=500;// 226

MainWindow::MainWindow() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = window = new Fl_Double_Window(main_width,main_height, PACKAGE_NAME " " PROGRAM_NAME " " VERSION);
    w = o;
    o->callback((Fl_Callback*)run_modal_callback, (void*)(this));
    o->when(FL_WHEN_CHANGED);
    { Fl_Menu_Bar* o = menubar = new Fl_Menu_Bar(0, 0, 512, 24, " ");
      o->box(FL_NO_BOX);
      o->menu(menu_menubar);
    }
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(560, 0, 40, 24);
      o->box(FL_NO_BOX);
      o->menu(menu_);
      setup_view_menu();
    }
    { Fl_Group* o = new Fl_Group(0, 24, 72, 352);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Button* o = new Fl_Button(4, 32, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_pen);
        o->callback((Fl_Callback*)cb_);
        o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
        o->setonly();
      }
      { Fl_Button* o = new Fl_Button(36, 32, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_tool_line);
        o->callback((Fl_Callback*)cb_1);
      }
      { Fl_Button* o = new Fl_Button(4, 64, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_tool_rect);
        o->callback((Fl_Callback*)cb_2);
      }
      { Fl_Button* o = new Fl_Button(4, 96, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_tool_circle);
        o->callback((Fl_Callback*)cb_3);
      }
      { Fl_Button* o = new Fl_Button(4, 160, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_tool_fill);
        o->callback((Fl_Callback*)cb_4);
      }
      { Fl_Button* o = new Fl_Button(36, 64, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_tool_frect);
        o->callback((Fl_Callback*)cb_5);
      }
      { Fl_Button* o = toolhider = new Fl_Button(20, 304, 32, 32);
        o->type(102);
        o->hide();
      }
      { Fl_Button* o = new Fl_Button(36, 96, 32, 32);
        o->type(102);
        o->box(FL_THIN_UP_BOX);
        o->image(image_tool_fcircle);
        o->callback((Fl_Callback*)cb_6);
      }
      o->resizable(0);
      o->end();
    }
    { W_Canvas* o = workspace = new W_Canvas(72, 24, 408, 336);
      o->box(FL_ENGRAVED_FRAME);
      o->color((Fl_Color)41);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_CENTER);
      o->when(FL_WHEN_RELEASE);
      window->resizable(workspace);
    }
    { Fl_Scrollbar* o = scroll_v = new Fl_Scrollbar(480, 25, 16, 335);
      o->box(FL_DOWN_BOX);
      workspace->scroll_v(scroll_v);
    }
    { Fl_Scrollbar* o = scroll_h = new Fl_Scrollbar(72, 360, 408, 16);
      o->type(1);
      o->box(FL_DOWN_BOX);
      workspace->scroll_h(scroll_h);
    }
    { Fl_Group* o = toolgrp = new Fl_Group(496, 24, 104, 351);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Button* o = fg = new Fl_Button(504, 32, 28, 28, "FG");
        fg->callback(W_Canvas::change_pen_callback, (void*)(0));
      }
      { Fl_Button* o = bg = new Fl_Button(540, 32, 28, 28, "BG");
        bg->callback(W_Canvas::change_pen_callback, (void*)(1));
      }
      { Fl_Scroll* o = new Fl_Scroll(497, 71, 100, 300);
        o->type(2);
        o->box(FL_FLAT_BOX);
        workspace->toolgroupparent(o);
        toolgrp->resizable(o);
        o->end();
      }
      //o->resizable(0);
      o->end();
    }
    { Fl_Group* o = new Fl_Group(0, 376, 602, 25);
      { Fl_Output* o = position = new Fl_Output(464, 381, 134, 16);
        o->labelfont(13);
        o->align(FL_ALIGN_RIGHT);
        workspace->position(position);
      }
      { Fl_Button* o = new Fl_Button(440, 379, 20, 20, "1");
        o->box(FL_THIN_UP_BOX);
        o->callback((Fl_Callback*)setscale, (void*)(SCALE_1));
      }
      { Fl_Slider* o = new Fl_Slider(224, 382, 210, 14);
        o->type(5);
        o->bounds(15,-15);
        workspace->scaler(o);
        o->parent()->resizable(o);
      }
      o->end();
    }
    window->xclass(PROGRAM_NAME);
    o->end();
  }
  //init workspace
workspace->tool(new ToolDot);
}

MainWindow::~MainWindow() {
  if(views->user_data()!=0)
    delete[] (((Fl_Menu_Item *)views->user_data())-1);delete window;
}

void MainWindow::run() {
  bool running=true;
window->show(/*Program::get().argc(),Program::get().argv()*/);
do{ 
  run_modal(window);
  running=false;
  while(selected()!=0)
    if(!close_file()){
       running=true; //User likes this program!
       break;
    }
}while(running==true);
window->hide();
}

void MainWindow::select_image(int index) {
  //bring image to front
MainBase::select_image(index);
workspace->canvas(selected());
workspace->redraw();
}

void MainWindow::open_argument_files() {
  //try to open everything thart was not parsed as a command line argument
Program& program=Program::get();
int arg;
while((arg=program.untouchedargument())!=0){
  const char *fname=program.argument(arg);
  char *errmsg;
  Canvas *c=File::open(fname,"*",&errmsg);
  if(c!=0)
    add(c);
  else
    ask("Error while opening file",0,errmsg,"OK");
}
setup_view_menu();
}

Win_AskSize::Win_AskSize() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = window = new Fl_Double_Window(348, 148, "Size of new image ?");
    w = o;
    o->callback((Fl_Callback*)run_modal_callback, (void*)(this));
    { Pattern_Input* o = width = new Pattern_Input(56, 16, 80, 28, "Width:");
      o->box(FL_DOWN_BOX);
      o->color(FL_BACKGROUND2_COLOR);
      o->selection_color(FL_SELECTION_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_LEFT);
      o->when(FL_WHEN_CHANGED);
      width->pattern("%]0,65535]d");
    }
    { Pattern_Input* o = height = new Pattern_Input(56, 56, 80, 28, "Height:");
      o->box(FL_DOWN_BOX);
      o->color(FL_BACKGROUND2_COLOR);
      o->selection_color(FL_SELECTION_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_LEFT);
      o->when(FL_WHEN_CHANGED);
      height->pattern("%]0,65535]d");
    }
    { Fl_Return_Button* o = btn_ok = new Fl_Return_Button(248, 112, 84, 28, "&OK");
      o->callback((Fl_Callback*)run_modal_callback);
    }
    { Fl_Button* o = new Fl_Button(148, 112, 84, 28, "&Cancel");
      o->callback((Fl_Callback*)run_modal_callback);
    }
    o->end();
  }
}

Win_AskSize::~Win_AskSize() {
  delete window;
}

bool Win_AskSize::run() {
  return run_modal(window)==btn_ok;
}
