// generated by Fast Light User Interface Designer (fluid) version 1.0106

#ifndef win_open_h
#define win_open_h
#include <FL/Fl.H>
#include "w_dirtree.h"
#include "streams.h"
#include "broadcaster.h"
#include "w_preview.h"
#include <FL/Fl_Double_Window.H>
extern void run_modal_callback(Fl_Double_Window*, void*);
#include <FL/Fl_Tile.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Return_Button.H>
extern void run_modal_callback(Fl_Return_Button*, void*);
#include <FL/Fl_Button.H>
extern void run_modal_callback(Fl_Button*, void*);
#include <FL/Fl_Choice.H>

class Win_Open {
  Directory *dir;
  Broadcaster dirchanged,filechanged; //p2=who changed this;
  static void dirtext_dir_changed(void *p1,void *p2);
  static void dirtext_file_changed(void *p1,void *p2);
public:
  Win_Open(Directory *d,const char *name,const char *opentext="Open");
private:
  Fl_Double_Window *window;
  Speedbar *speedbar;
  DirTreeBrowser *dirtree;
  static Fl_Menu_Item menu_Options[];
  static Fl_Menu_Item *m_show_hidden;
  inline void cb_m_show_hidden_i(Fl_Menu_*, void*);
  static void cb_m_show_hidden(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_order_by_name;
  inline void cb_m_order_by_name_i(Fl_Menu_*, void*);
  static void cb_m_order_by_name(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_order_ext;
  inline void cb_m_order_ext_i(Fl_Menu_*, void*);
  static void cb_m_order_ext(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_order_atime;
  inline void cb_m_order_atime_i(Fl_Menu_*, void*);
  static void cb_m_order_atime(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_order_mtime;
  inline void cb_m_order_mtime_i(Fl_Menu_*, void*);
  static void cb_m_order_mtime(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_order_ctime;
  inline void cb_m_order_ctime_i(Fl_Menu_*, void*);
  static void cb_m_order_ctime(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_order_backwards;
  inline void cb_m_order_backwards_i(Fl_Menu_*, void*);
  static void cb_m_order_backwards(Fl_Menu_*, void*);
  FileBrowser *filebrowser;
  FileInputBox *dirtext;
  inline void cb_dirtext_i(FileInputBox*, void*);
  static void cb_dirtext(FileInputBox*, void*);
  static Fl_Menu_Item menu_Speedbar[];
  static Fl_Menu_Item *m_speedbar_insert;
  inline void cb_m_speedbar_insert_i(Fl_Menu_*, void*);
  static void cb_m_speedbar_insert(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_speedbar_edit;
  inline void cb_m_speedbar_edit_i(Fl_Menu_*, void*);
  static void cb_m_speedbar_edit(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_speedbar_remove;
  inline void cb_m_speedbar_remove_i(Fl_Menu_*, void*);
  static void cb_m_speedbar_remove(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_speedbar_left;
  inline void cb_m_speedbar_left_i(Fl_Menu_*, void*);
  static void cb_m_speedbar_left(Fl_Menu_*, void*);
  static Fl_Menu_Item *m_speedbar_right;
  inline void cb_m_speedbar_right_i(Fl_Menu_*, void*);
  static void cb_m_speedbar_right(Fl_Menu_*, void*);
  Fl_Return_Button *btn_open;
  Fl_Choice *extension_list;
  inline void cb_extension_list_i(Fl_Choice*, void*);
  static void cb_extension_list(Fl_Choice*, void*);
public:
  ~Win_Open();
  bool run();
  void extensions(const char **ext,const char **description);
  const char * file(int& i);
  const char * extension();
};
#include <FL/Fl_Input.H>

class Win_Open_Helper {
public:
  Win_Open_Helper(Speedbar::Item *i);
private:
  Fl_Double_Window *window;
  Fl_Input *p_name;
  Fl_Input *p_icon;
  Fl_Input *p_cmd;
  Fl_Input *p_dir;
  Fl_Return_Button *ok_button;
public:
  ~Win_Open_Helper();
private:
  Speedbar::Item *item;
public:
  void run();
};
#endif
