//// PoloCalc for windows
//// File / Fichier :   HVSmartInput.cpp
//// Copyright (C) 2003 Hugues Vanden Bossche
//// Last modification / Dernire modification : 24/04/2003
//// Definition of an input that filters keys before accepting them
//// and check for specific operations

// =============================================================================
//    This file is part of PoloCalc, a Windows desk caculator using
//    the Reverse Polish Notation
//
//    PoloCalc is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    PoloCalc is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with PoloCalc; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// ============================================================================= 

#include "HVSmartInput.h"

//==============================================================================
//  Member functions definitions
//==============================================================================

// fonction handle
int HV_SmartInput::handle(int event)
{  
  if(event==FL_KEYBOARD)
  {    
    int theKey = Fl::event_key();
    vector<int>::iterator findKey = find( hotKeys.begin(), hotKeys.end(),theKey);

    if (findKey!=hotKeys.end())
    {
      (* hotAction)( theKey );
      return 1;
    }  
    else   
      return Fl_Input::handle(event);       
  }
  else   
    return Fl_Input::handle(event); 
}


