//// PoloCalc for windows
//// File/Fichier : main.h
//// Copyright (C) 2003 Hugues Vanden Bossche
//// Last modification / Dernire modification : 18/05/2003
//// This is the main file, that contains the program to emule an HP type
//// calculator

//==============================================================================
//  Global constantes and variables
//==============================================================================

// program and version
const char* PRGNAME = "CineCalc";
const char* AUTHOR = "Based on PoloCalc 1.01 by Hugues Vanden Bossche";
const int YYYY = 2004;
const char* VERSION = "0.1";

#define default_poc_file "DefaultFile.poc"
#define help_file "data/help.htm"

// Choice of language
const int FRENCH = 1;
const int ENGLISH =0;
int lang;
enum HV_mesnum { NBARG1, NBARGB, NBARGE, TYPEARG, DIV0, LN0, FILEMESS, TARGET, SOURCE, 
                 MENUFILE, MENUSD, MENULD, MENUSF, MENULF, 
                 MENUEDIT, MENUC, MENUCA, MENUU,
                 MENUSTACK, MENUHELP, MENUABOUT,
                 NBMESS }; 
const char* HV_messages[2][NBMESS] = {
{ "I Need an argument.",
  "I Need ",
  " arguments.",
  "Wrong type of argument.",
  "I Can't divide by 0.",
  "I Can't do ln(0) or Log(0).",
  "Access error for File: ",
  "Target File",
  "Source File",
  "&File", "&Save default", "&Load default", "S&ave file", "L&oad file",
  "&Edit", "&Copy", "C&opy All", "&Undo",
  "&Stack", "&Help", "&About"
},
{ "Il me faut quand mme un argument.",
  "Il me faut  ",
  " arguments.",
  "Type d'argument inadquat.",
  "Erreur : division par 0.",
  "Erreur : ln(0) or Log(0).",
  "Problme d'accs au fichier : ",
  "Fichier cible",
  "Fichier source",
  "&Fichier", "&Sauver dfaut", "&Ouvrir dfaut", "S&auver fichier", "O&uvrir fichier",
  "&Edition", "&Copier", "C&opier tout", "&Annuler",
  "&Pile", "&Aide", "A &propos"  
}};

// Choice of unit used for trigonometry
HV_TRIGO trigo = DEG;

// Elements of the board that can be accessed from anywhere
HV_TextScroll *outpt;
HV_SmartInput *inpt;
HV_OperationKey *angle;
Fl_Menu_Button *varMenu, *rmMenu;

// List of double functions keys
vector<HV_DoubleOperationKey*> listOfDoubleKeys;
bool doubleKeysInversed = false;

// Main list and its copy
HV_List *HPPile, *copyPile;

// list of operation that can be access by a shortcut 
enum operations{ ENTER=1, ADD, SUB, MUL, DIV, DROP, DROPTOINPT, CLEAR, OPP, INV,
LN, LOG10, COS, SIN, TAN, SETUNIT, SWAP, PICK, UNDO, SQR, POW, INVK, COPY};

// shortcut definition
const int correspond[][2]={ { 65407, CLEAR },
                            { 65455, DIV },
                            { 65450, MUL },
                            { 65453, SUB },
                            { 65451, ADD },                                                             
                            { 65293, ENTER },
                            { 65421, ENTER },
                            { 65364, DROPTOINPT },
                            { 65470, INVK},
                            { 65471, COPY},
                            { 65472, OPP},
                            { 65473, INV},
                            { 65474, DROP},
                            { 65475, SWAP},
                            { 65476, PICK},
                            { 65477, UNDO},    
                            { 65478, SQR}, 
                            { 65479, POW}, 
                            { 65480, LN}, 
                            { 65481, LOG10 },                               
                            { 65535, CLEAR }};