#include <FL/Fl.H>
#include <FL/Fl_Box.H>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <FL/glut.h>
#include "Fl_Tb_Window.h"
//#include "util.h"

class Torus : public Tb_Window {
public:
  Torus(int x, int y, int w, int h, const char *l = 0)
    : Tb_Window(x, y, w, h, l) { init = 0; }
  Torus(int w, int h, const char *l = 0)
    : Tb_Window(w, h, l) { init = 0; }
  void draw();
  void make_torus();
  int init;
  int list;
  void set_list(int l) { list = l; }
};

void Torus::draw() {
  set_zoom(get_zoom()+.5);
  
  if (!valid()) {
    glViewport(0, 0, w(), h());
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(30., (GLdouble)w() / h(), 50., 150.);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(0., 0., 100., 0., 0., 0., 0., 1., 0.);
    glClearColor(1., 1., 1., 1.);
    glEnable(GL_DEPTH_TEST);
  }
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glPushMatrix();
  transform();
  if (init) {
    glCallList(list);
  }
  glPopMatrix();
}

void Torus::make_torus() {
  make_current();
  
  glNewList(list, GL_COMPILE);
  glTranslatef(1.1f, 1.1f, 1.1f);
  glColor3f(0., 0., 0.);
  if (list == 1) {
    glutWireTorus(5., 10., 10, 20);
  } else {
    glutWireTorus(5., 15., 10, 20);
  }
  glEndList();
  
  init = 1;
}

void doit(void *t0) {
  Torus *t = (Torus *)t0;
  t->make_torus();
  //        t->set_changed();
  //        t->redraw();
}

int main(int argc, char **argv) {
  Fl_Window *w = new Fl_Window(250, 250, "Window 1");
  w->resizable(w);
  
  Fl_Box *b = new Fl_Box(48, 48, 154, 154);
  b->box(FL_DOWN_BOX);
  
  /* Separate window. */
  
  /*
  Torus *t1 = new Torus(200, 200, "Torus 1");
  t1->mscale(.1);
  t1->resizable(t1);
  t1->set_list(1);
  t1->show();
  t1->idle_redraw(1);
  */
  /* Finish Window 1. */
  
  Torus *t2 = new Torus(50, 50, 150, 150, "Torus 2");
  
  w->add(t2);             // 'cause Fl_Gl_Window does end()
  w->show();
  t2->set_list(2);
  t2->show();
  t2->redraw();
  
  /* Tell the tori to make themselves later. */

  //Fl::add_timeout(4., doit, t1);
  Fl::add_timeout(0., doit, t2);
  
  return Fl::run();
}
