%{ 
// Extreme Wave -- A 3d modelling and animation environment
// Copyright (C) 1999 James Dean Palmer
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// Please report all bugs and problems to "james@tiger-marmalade.com".

// -*- C -*- 

#include <stdio.h> 
#include <string.h> 
#include "nativeio.tab.h" 
%} 
%% 
 
[\n\t ]+             { /* ignored */ ; } 
[+-]?[0-9]+          { 
                       yylval.eint = atoi(yytext);  return INTEGER;  
                     } 
[+-]?([0-9]+|([0-9]*\.[0-9]+)([eE][+-]?[0-9]+)?) {  
                       yylval.edouble = atof(yytext); return DOUBLE;  
                     } 
format               { return FORMAT; }
version              { return VERSION; }
pointlist            { return POINTLIST; }
bonelist            { return BONELIST; }
dmaterial            { return MATERIAL; }
materiallist         { return MATERIALLIST; }

[a-zA-Z\_\-]+        {  yylval.estring = strdup(yytext);
                      return WORD; 
                     }
\"[^\"\n]*\"         {  
                       yylval.estring = strdup(yytext+1); 
                       if (yylval.estring[yyleng-2] != '\"') 
                         printf("warning: unterminated character string.\n"); 
                       else 
                         yylval.estring[yyleng-2] = '\0'; 
                       return TEXT;  
                     } 
\#[^\n]*\n           { /* comment */ ; } 
\;[^\n]*\n           { /* comment */ ; } 
\(!                  { return OSTART; }
\(                   { return VSTART; } 
\)                   { return END; } 
 
%% 

int yywrap () 
{
  return 1;
}
