#include <math.h>
#include <ewave\objects\ew_object.h>

extern double global_time;
/*
typedef struct Coefficient_Value
{
  double value[2];
  double tension;
  double continuity;
  double bias;
  // int id;
} EW_KB_Value;
*/
//typedef Coefficient deque<Coefficient_Value>;
//typedef Coefficient_deque deque<Coefficient>;

/*
class Coeff : public UBase
{
 public:
  Coeff& operator=(const Coeff&);
  Coeff& operator[](int offSet) { return *value[offSet]; }
  const Coeff& operator[](int offSet) const { return *value[offSet]; }
  int size() const { return value.size(); }
  void append (int n) { value.append (n); }
  
 protected:
  Coefficient_array value;
};
*/

class EW_KB_Value_array : public EW_array 
{
public:
  EW_KB_Value_array()
    {
      _item_size = sizeof(EW_KB_Value);
      _size = 0; 
      _data = 0; 
      cache[0] = -1;
      id_ = unique_id;
      unique_id++;
    }

  EW_KB_Value_array(EW_int q) 
    {
      _item_size = sizeof(EW_KB_Value);
      _size = 0;
      _data = 0;
      append(q);
      id_ = unique_id;
      unique_id++;
    }

  EW_KB_Value & first() { return (EW_KB_Value &)EW_array::first(); }
  EW_KB_Value & last() { return (EW_KB_Value &)EW_array::last(); }
  EW_KB_Value & operator[](EW_int i) { return (EW_KB_Value &)_data[i*_item_size]; }
  EW_KB_Value & data(EW_int i) { return (EW_KB_Value &)_data[i*_item_size]; }
  EW_KB_Value & append(EW_int s) { return (EW_KB_Value &)EW_array::append(s); }
  EW_KB_Value & append() { return append(1); }
  EW_KB_Value & insert(EW_int n, EW_int s) { return (EW_KB_Value &)EW_array::insert(n, s); }
  EW_KB_Value * data() { return (EW_KB_Value *)_data; }
  double        value (double time); // get value
  double        value () { return value(global_time); } // get value
  void          value (double time, double x); // set value
  inline int    id() { return id_; }
 protected:
  int           id_;
  sgVec2        cache[2];
};

typedef EW_KB_Value_array EW_KB_Spline;
typedef EW_KB_Value_array EW_CoEff;

typedef EW_KB_Value_array * EW_CoEff_ptr;

class EW_CoEff_array : public EW_ptr_array 
{
public:
  EW_CoEff_ptr & first() 
    { return (EW_CoEff_ptr &)EW_array::first(); }
  EW_CoEff_ptr & last() 
    { return (EW_CoEff_ptr &)EW_array::last(); }
  EW_CoEff_ptr & operator[](EW_int i) 
    { return (EW_CoEff_ptr &)_data[i*_item_size]; }
  int lookup (int x)
    {
      int i, n = size();
      // TODO - Keep sorted by ID and use a binary search to find coefficients.
      for (i = 0; i < n; i++)
	{
	  if (data(i)->id() == x) return i;
	}
      return -1;
    }
  EW_Vec3 operator[](EW_Point i) 
    { 
      return EW_Vec3 ((data(lookup(i[0]))->value()),
		      (data(lookup(i[1]))->value()),
		      (data(lookup(i[2]))->value()));
    }
  EW_CoEff_ptr & append(EW_int s) 
    { 
      int j = size();
      EW_array::append(s);
      for (int i = 0; i < s; i++)
	data(size()-i-1) = new EW_CoEff();
      return data(j); 
    }
  EW_CoEff_ptr & append() 
    { return append(1); }
  EW_CoEff_ptr & insert(EW_int n, EW_int s) 
    { 
      EW_array::insert(n, s); 
      for (int i = n; i < (n+s); i++)
	data(i) = new EW_CoEff();      
      return data(n);
    }
  EW_CoEff_ptr * data() 
    { return (EW_CoEff_ptr *)_data; }
  EW_CoEff_ptr & data(EW_int i) { return (EW_CoEff_ptr &)_data[i*_item_size]; }
  EW_Vec3 get (EW_Point i, double jtime) 
    { 
      return EW_Vec3 (data(lookup(i[0]))->value(jtime),
		      data(lookup(i[1]))->value(jtime),
		      data(lookup(i[2]))->value(jtime) );
    }
  EW_Vec3 get (EW_Point i) { return get (i, global_time); }
  void set (EW_Point i, double j, EW_Vec3 k) { // set the coeff to k at time j
    data (lookup(i[0]))->value(j, k.x());
    data (lookup(i[1]))->value(j, k.y());
    data (lookup(i[2]))->value(j, k.z());
  }
  void set (EW_Point i, EW_Vec3 j) { set (i, global_time, j); }
  EW_Point new_point ()
    {
      int i = size();
      append (3);
      return EW_Point (data(i)->id(), data(i+1)->id(), data(i+2)->id());
    }
};



