#include <ewave/geometry/mesh.h>
#include <GL/gl.h>


void Mesh::add_face (long a, long b, long c, long d)
{
  //printf("add_face::\n");
  //printf("faces:: %ld, %ld, %ld, %ld\n", a, b, c, d);
  vector<long> s, u, y, t, r;
  t.push_back (a);
  t.push_back (b);
  t.push_back (c);
  t.push_back (d);
  
  faces.push_back (t);
}

void Mesh::add_face (Vec3 a, Vec3 b, Vec3 c, Vec3 d, // points
	       Vec3 e, Vec3 f, Vec3 g, Vec3 h) // normals
{
  add_face (add_point_and_normal (a, e), 
	    add_point_and_normal (b, f),
	    add_point_and_normal (c, g),
	    add_point_and_normal (d, h));
}

long Mesh::add_point_and_normal (Vec3 a, Vec3 b)
{ 
  if (!duplicate_vertices)
    {
      for (unsigned long i = 0; i < points.size (); i++)
	{
	  if (a == points[i]) 
	    {
	      if (b == normals[i])
		{
		  //printf ("add_point_and_normal - DUPE %ld\n", i);
		  return i;
		}
	    }
	}
    }
  points.push_back (a);
  normals.push_back (b);
  //printf ("add_point_and_normal - NEW  %ld\n", points.size ()-1);
  return (points.size () - 1);
}

void Mesh::draw ()
    {
      /*
      GLfloat light0_pos[4]   = { -5000.0, 5000.0, 0.0, 0.0 };
      GLfloat light0_color[4] = { .6, .6, .8, 1.0 };
      
      glLightfv(GL_LIGHT0, GL_POSITION, light0_pos);
      glLightfv(GL_LIGHT0, GL_DIFFUSE,  light0_color);  
      glEnable(GL_LIGHT0);
*/
      for (unsigned long j = 0; j < faces.size (); j++)
	{
	  glBegin (GL_POLYGON);
	  for (unsigned long i = 0; i < (faces[j]).size(); i++)
	    {
	      unsigned long k = (faces[j])[i];
	      glNormal3dv ( normals[k].value () );
	      glVertex3dv ( points[k].value () );
	    }
	  glEnd ();
	}
    }
  
void Mesh::drawq ()  // draw without normal information
    {
      for (unsigned long j = 0; j < faces.size (); j++)
	{
	  glBegin (GL_POLYGON);
	  for (unsigned long i = 0; i < (faces[j]).size(); i++)
	    {
	      unsigned long k = (faces[j])[i];
	      glVertex3dv ( points[k].value () );
	    }
	  glEnd ();
	}
    }

void Mesh::operator= (const Mesh& v) 
{ 
  points = v.points;
  normals = v.normals;
  faces = v.faces;
}
