#ifndef MESH_H
#define MESH_H

//#include <ewave/kernel/array.h>
#include <ministl/vector.h>
#include <ewave/geometry/math.h>

typedef vector<long> Face;

class Mesh : public Base {
 public:

  Mesh () { duplicate_vertices = 0; }
  virtual ~Mesh () {}
  void add_face (long a, long b, long c, long d);
  void add_face (Vec3 a, Vec3 b, Vec3 c, Vec3 d, // points
		 Vec3 e, Vec3 f, Vec3 g, Vec3 h); // normals
  long add_point_and_normal (Vec3 a, Vec3 b);
  void draw ();
  void drawq ();  // draw without normal information
  void operator= (const Mesh& v);
  void allow_duplicate_vertices () { duplicate_vertices = 1; }
  void disallow_duplicate_vertices () { duplicate_vertices = 0; }
  
 protected:
  vector<Vec3> points;
  vector<Vec3> normals;
  vector<Face> faces;
  short duplicate_vertices;
};

/*

 New mesh that supports storing redundant information more compactly and
 
typedef long Edge[2];

class Face : public Base {
  vector<long> edges;  // index of each edge;
  vector<long> material; // index of each material material.size() = 2X edges size
  char mark;
};

class Mesh2 : public Base {
 public:

 void draw ()
  {
    
  }

  // Return a bounding box for this mesh. 
  void bounding_box ()
  {
  }

  void cull ()
  {
  } 
  
  vector<Face> faces;
  vector<Edge> edges;
  vector<Vec3> vertices;
  vector<Material> material;
};
 
*/

#endif
