#ifndef ARCBALL_H
#define ARCBALL_H

#include <ewave/geometry/vec3.h>
#include <ewave/geometry/quat.h>

typedef enum AxisSet {NoAxes, CameraAxes, BodyAxes, OtherAxes, NSets} AxisSet;
typedef double *ConstraintSet;

class ArcBall {
 public:
  ArcBall ();
  void ArcBall::place (Vec3 center, double radius);
  void ArcBall::mouse (Vec3 vNow);
  void ArcBall::useSet (AxisSet axisSet);
  void ArcBall::showResult ();
  void ArcBall::hideResult ();
  void ArcBall::update ();
  HMatrix ArcBall::value ();
  void ArcBall::beginDrag ();
  void ArcBall::endDrag ();
  void ArcBall::draw ();
  
 protected:
  Vec3 center;
  double radius;
  Quat qNow, qDown, qDrag;
  Vec3 vNow, vDown, vFrom, vTo, vrFrom, vrTo;
  HMatrix mNow, mDown;
  short ShowResult, dragging;
  ConstraintSet sets[NSets];
  int setSizes[NSets];
  AxisSet axisSet;
  int axisIndex;
  
 private:
  void ArcBall::drawAnyArc (Vec3 vFrom, Vec3 vTo);
  void ArcBall::drawHalfArc (Vec3 n);
  void ArcBall::drawConstraints ();
  void ArcBall::drawDragArc ();
  void ArcBall::drawResultArc ();
  
  Vec3 mouseOnSphere (Vec3 mouse, Vec3 ballCenter, double ballRadius);
  Vec3 constrainToAxis (Vec3 loose, Vec3 axis);
  int nearestConstraintAxis (Vec3 loose, Vec3 *axes, int nAxes);
  Quat quatFromBallPoints (Vec3 from, Vec3 to);
  void quatToBallPoints (Quat q, Vec3 *arcFrom, Vec3 *arcTo);
};

#endif
