#ifndef FL_SG_TREE_H
#define FL_SG_TREE_H

#include "Fl_ToggleTree/Fl_ToggleTree.H"
#include <ewave/objects/ew_object.h>

class Fl_SG_Tree : public Fl_ToggleTree 
{
 public:
  Fl_SG_Tree(int x, int y, int w, int h) : Fl_ToggleTree (x, y, w, h)
    {
    }
  virtual ~Fl_SG_Tree() {};

  void rebuild (EW_Object *current = 0, int sub = 0)
    {
      if (current == 0)
	{
	  clear ();
	  current = kernel->scene;
	}
      Fl_Pixmap *pix = current->vklass().pixmap();
      char *name = strdup (current->get_name ());
      Fl_ToggleNode * node = new Fl_ToggleNode (name, 
						(int)current->is_group(), 
						pix, 
						(void *)current);
      //scene_graph->traverse_start(scene_graph->find((void *)kernel->current_object->get_parent()));
      if (sub)
	add_sub (node);
      else
	add_next (node);
      
      if (current->is_group ())
	{
	  EW_Group * current_group = (EW_Group *) current;
	  
	  int flag = 1;
	  //for (unsigned long int i = 0; i < current_group->children.size(); i++)
	  for (EW_Object_List::cursor i = current_group->children.begin (); &i; i++)
	    {
	      rebuild ((&i), flag);
	      flag = 0;
	    }
	      
	}
      
    }
};

#endif
