
#if defined(_MSC_VER)  // Identifying MS VC++ compilers

         // Special headers for MS compilers  

	#include <wtypes.h>

	#include <wingdi.h>  



#endif

#include <ewave/objects/ew_object.h>
#include <ewave/objects/ew_group.h>
//#include <ewave/global.h>
//#include <ewave/objects/polygon3.h>
#include <ewave/importers/3ds.h>

extern void redraw_viewports();

void EW_3DS::initialize()
{
  pdb_record w;
  w.name = "3DS-import";
  w.author = "Will Newton <will@south-of-heaven.demon.co.uk>";
  w.docstring = "Import a 3DS object file";
  w.procedure = EW_3DS::import;
  add_pdb_record(w);
}

SCM EW_3DS::import(SCM a)
{
  /*
   Code to parse 3DS file and build the scene.
   For an example of how to do this - you can look at nativeio.y
   and nativeio.l.  They are flex-bison grammars that read the
   Extreme Wave format and build the scene.  But you can build
   the parser any way you like.
   */
  char *filename;
  H3DSFile newfile;
  int i,j,pstart=0;
  
  EW_Group *imported_group = new EW_Group();
  
  filename = fl_file_chooser("Open a 3DS file","*.3ds",NULL);
  
  if (newfile.read3DS(filename))
    {
      imported_group->name (filename);
      
      for (i=0; i< (newfile.meshobjs-1) ; i++)
	{
	  printf("new group %d\n", i);
	  EW_Group *meshgroup = new EW_Group();
	  
	  pstart = point_db.size();
	  point_db.append(newfile.meshobjlist[i].vertices);
	  
	  for (j=0 ; j<newfile.meshobjlist[i].vertices;j++)
	    {
	      printf("new vertex %d\n", j);
	      point_db[pstart+j].xyz[0] = newfile.meshobjlist[i].vertlist[j].x;
	      point_db[pstart+j].xyz[1] = newfile.meshobjlist[i].vertlist[j].y;
	      point_db[pstart+j].xyz[2] = newfile.meshobjlist[i].vertlist[j].z;
	    }
	  
	  meshgroup->name (newfile.meshobjlist[i].name);
	  
	  for (j=0;j<newfile.meshobjlist[i].faces;j++)
	    {
	      printf("new poly %d\n", j);
	      EW_Polygon3 *newpoly = new EW_Polygon3();
	      newpoly->control_points[0] =
		pstart+newfile.meshobjlist[i].facelist[j].p0;
	      newpoly->control_points[1] =
		pstart+newfile.meshobjlist[i].facelist[j].p1;
	      newpoly->control_points[2] =
		pstart+newfile.meshobjlist[i].facelist[j].p2;
	      meshgroup->add(newpoly);
	    }
	  
	  imported_group->add(meshgroup);
	  printf("#mesh objs%d\n", newfile.meshobjs);
	  
	}
      
      scene->add(imported_group);
    }
  redraw_viewports();
  return SCM_BOOL_T; // Loaded okay.
}

