
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
//#include <libguile.h>
#include <ewave/FakeGuile.h>
#include <FL/fl_file_chooser.H>

class EW_3DS {

 public:
  EW_3DS() {};
  ~EW_3DS() {};
  static void initialize();
  static SCM import(SCM a);
};


typedef unsigned short H3dsshort;
typedef unsigned char H3dschar;
typedef float H3dsfloat;
typedef unsigned long H3dslong;
typedef unsigned short H3dsword;

enum {
	CHUNK_RGBF      	= 0x0010,
	CHUNK_RGBB      	= 0x0011,
//	CHUNK_RBGB2     	= 0x0012,	// ?? NOT HLS.
	CHUNK_MAIN      	= 0x4D4D,
	CHUNK_OBJMESH		= 0x3D3D,
	CHUNK_BKGCOLOR		= 0x1200,
	CHUNK_AMBCOLOR  	= 0x2100,
	CHUNK_OBJBLOCK  	= 0x4000,
	   CHUNK_TRIMESH   	= 0x4100,
		CHUNK_VERTLIST  = 0x4110,
		CHUNK_FACELIST  = 0x4120,
		CHUNK_FACEMAT   = 0x4130,
		CHUNK_MAPLIST   = 0x4140,
		CHUNK_SMOOLIST  = 0x4150,
		CHUNK_TRMATRIX  = 0x4160,
	   CHUNK_LIGHT     	= 0x4600,
		CHUNK_SPOTLIGHT = 0x4610,
	   CHUNK_CAMERA    	= 0x4700,
	 CHUNK_MATERIAL  	= 0xAFFF,
	  CHUNK_MATNAME   	= 0xA000,
	  CHUNK_AMBIENT   	= 0xA010,
	  CHUNK_DIFFUSE   	= 0xA020,
	  CHUNK_SPECULAR  	= 0xA030,
	  CHUNK_TEXTURE   	= 0xA200,
	  CHUNK_BUMPMAP   	= 0xA230,
	  CHUNK_MAPFILE   	= 0xA300,
	 CHUNK_KEYFRAMER 	= 0xB000,
	  CHUNK_FRAMES      = 0xB008
};

struct H3dsFace {
	H3dsword p0,p1,p2;
	H3dsword flags;
};

struct H3dsVert {
	union { H3dsfloat x; H3dslong ix; };
	union { H3dsfloat y; H3dslong iy; };
	union { H3dsfloat z; H3dslong iz; };
};

struct H3dsMap {
	union { H3dsfloat u; H3dslong iu; };
	union { H3dsfloat v; H3dslong iv; };
};


struct H3dsMeshObj {
	int faces;
	int vertices;
	int maps;
	short matrix;
	H3dsFace *facelist;
	H3dsVert *vertlist;
	H3dsMap *maplist;
	H3dsfloat transmatrix[3*4];
	char name[16];
};

class H3DSFile {

     public:
	FILE *fh;
	int error;
	int meshobjs;
	H3dsMeshObj *meshobjlist;

	void fileRead(void * dest, int len);
	void fileSetPos(unsigned long pos);
	unsigned long fileGetPos(void);
	H3dsMeshObj *getMeshObj(void);
	void *getmem(int size);
	void readVertList(H3dsMeshObj *meshobj);
	void readFaceList(H3dsMeshObj *meshobj);
	void readMapList(H3dsMeshObj *meshobj);
	void readTransMatrix(H3dsMeshObj *meshobj);
	void readTriMeshBlocks(H3dslong p, char *name);
	void readObjBlocks(H3dslong p);
	void readObjMeshBlocks(H3dslong p);
	void readMainBlocks(H3dslong p);
	short openFile(char *name);

	H3DSFile();
	~H3DSFile();
	short read3DS(char *filename);
};

