#ifndef _ARRAY_
#define _ARRAY_

#include <stdlib.h>
#include <string.h>
//#include <strings.h>
#include <ewave/kernel/base.h>

template <class T>
class PArray : public UBase
{
 public:
  typedef T* Tptr;
  
  PArray (unsigned long x)
    {
      data = (Tptr*) malloc (sizeof(Tptr)*x);
      length = x;
    }
  PArray () { data = 0; length = 0; }
  ~PArray () 
    { 
      if (data) 
	{
	  free(data); 
	  data = 0;
	}
    }
  
  void clear () 
    { 
      if (data) 
	{
	  free (data); 
	  data = 0;
	}
      length = 0; 
    }
  
  unsigned long size () { return length; }

  T*& operator[] (int x)
    {
      return data[x];
    }
  
  int resize (unsigned long x)
    {
      if (x == 0)
	{
	  clear ();
	  return 0;
	}
      data = (Tptr*) realloc (data, sizeof(Tptr)*x);
      length = x;
      return 0;
    }
  
  int push_back (T * item)
    {
      unsigned long x = length + 1;
      resize (x);
      data[x-1] = item;
      return 0;
    }

  int insert (unsigned long y, T * item)
    {
      unsigned long x = length + 1;
      resize (x);
      for (unsigned long i=(length-1); i>y; i--)
	{
	  data[i] = data[i-1];
	}
      data[y] = item;
      return 0;
    }
  
  int erase (unsigned long x)
    {
      if (x > length) return -1;
      for (unsigned long i = x; i < length; i++)
	{
	  if ((i+1) < length)
	    data[i] = data[i+1];;
	}
      resize (length-1);
	  return 0;
    }

    void operator= (const PArray& v) 
    { 
      //printf("PArray::Making copy..\n");
      resize (v.length);
      for (unsigned long int i=0; i<length; i++)
	{
	  data[i] = v.data[i];
	}
    }
  
 protected:
  Tptr *data;
  unsigned long length;
};

inline unsigned long AMin ( unsigned long a, unsigned long b) { return ( a < b ) ? a : b ; }

template <class T>
class Array : public UBase
{
 public:
  
  Array (unsigned long x)
    {
      //data = (T*) malloc (sizeof(T)*x);
      data = new T[x];
      length = x;
    }
  Array () { data = 0; length = 0; }
  ~Array () 
    { 
      if (data) 
	{
	  //free (data); 
	  delete data;
	  data = 0;
	}
    }
  
  void clear () 
    { 
      if (data) 
	{
	  //free (data); 
	  delete data;
	  data = 0;
	}
      length = 0; 
    }
  
  unsigned long size () { return length; }

  T& operator[] (int x)
    {
      return data[x];
    }
  
  int resize (unsigned long x)
    {
      unsigned long i;
      if (x <= 0)
	{
	  clear ();
	  return 0;
	}

      //data = (T*) realloc (data, sizeof(T)*x);
      printf("resize::New.. %ld\n", x);
      T * tmp = new T[x];

     printf("resize:New Okay..\n");
      for (i = 0; i < AMin (length, x); i++) 
	tmp[i] = data[i];

      printf("resize::Copy Okay..\n");
      delete data;
      printf("resize:Delete Okay..\n");
      data = tmp;
      length = x;
      return 0;
    }
  
  int push_back (T item)
    {
      unsigned long x = length + 1;
      if (resize (x))
	return 1;
      data[x-1] = item;
      return 0;
    }
  
  int insert (unsigned long y, T item)
    {
      unsigned long x = length + 1;
      resize (x);
      for (unsigned long i=(length-1); i>y; i--)
	{
	  data[i] = data[i-1];
	}
      data[y] = item;
      return 0;
    }
  
	int erase (unsigned long x)
	{	if (x > length)
		{	return -1;
		}
		for (unsigned long i=x; i<length; i++)
		{	if ((i+1) < length)
			data[i] = data[i+1];;
		}
		resize(length-1);
		return 0;//bug
	}

  int operator == (Array& s) const
    {
      if (s.size() != length) return 0;
      for (unsigned long i=0; i < length; i++)
	if (s[i] != data[i]) return 0;
      return 1;
    }

  void operator= (const Array& v) 
    { 
      printf("Array::Making copy..\n");
      printf("Array::resizing from %ld \n", length);
      printf("Array::to %ld..\n\n", v.length);
      resize (v.length);
      printf("Done resize\n");
      for (unsigned long i=0; i<v.length; i++)
	{
	  data[i] = v.data[i];
	}
      printf("Done copying.\n");
    }
  
 protected:
  T *data;
  unsigned long length;
};

#endif
