/* Extreme Wave -- A 3d modelling and animation environment
   Copyright (C) 1999 James Dean Palmer
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Please report all bugs and problems to "james@tiger-marmalade.com".

   "My global mind reaches out for the truth." -- Queensryche
*/
#include <unistd.h>
#include <ewave/kernel/global.h>

#include <FL/Fl_Scroll.H>
extern Fl_Scroll *object_inspector_group;

int current_point;
int SelectedBone;
int global_click;

Global global;

Global::Global() {}

void
Global::add_object (EW_Class *b)
{
  kernel->object_registry.insert (b);
  object_inspector_group->add(b->inspector());
  b->inspector()->hide();
  b->inspector()->position(object_inspector_group->x()+4,
			   object_inspector_group->y()+4);
}

void
Global::set_object(const char *a)
{
  current_object_record = kernel->object_registry.search (a);
  if (!current_object_record)
  printf("ERROR! -- Could not find \"%s\"\n", a);
}

EW_Object *
Global::new_object()
{
  EW_Object * b = (current_object_record->create())();
  if (b==NULL) 
    printf("NULL object");
  return b;
}

void
Global::set_properties(const char *a)
{
  EW_Class *record = kernel->object_registry.search (a);

  if (record == kernel->current_record) return;
  if (record)
    {
      if (kernel->current_record)
	{
	  if (kernel->current_record->inspector() == record->inspector())
	    return;
	  kernel->current_record->inspector()->hide ();
	}
      record->inspector()->show ();
      kernel->current_record = record;
    }
  else
    {
      if (kernel->current_record)
	kernel->current_record->inspector()->hide ();
      kernel->current_record = 0;
    }
  return;
}
