#include <gFL/guile_fltk.h>
#include <ewave/kernel/base.h>

static SCM
Smark (SCM widget_smob)
{
  return SCM_BOOL_F;
}

static scm_sizet
Sfree (SCM smob)
{
  delete (UBase *) gh_cdr (smob);
  gfl_remove (smob);
  return (sizeof (GFL_Widget) + sizeof (UBase));
}

static int
Sprint (SCM smob, SCM port, scm_print_state *pstate)
{
  scm_puts ("#<obj ubase >", port);
  return 1;
}

/*
   2.  Smob definition:
*/

GFL_SUBCLASS_TYPE ("ewave-ubase", 
		   "The ubase class.",
		   ew_ubase, ew_base,
		   Smark, Sfree, Sprint);

GFL_PROCEDURE_2_0
( ew_ubase_set_id, 
  "ewave-ubase::set-id", 
  "Sets the object id.  Use with caution.", 
  obj, a, 
  ew_ubase, long)
{
  GFL_ASSERT_2(ew_ubase_set_id, obj, a);
  UBase *w = (UBase *) gh_cdr(obj);
  w->set_id (gh_scm2long(a));
  return SCM_UNSPECIFIED;
}

GFL_PROCEDURE_1_1
( ew_ubase_get_id, 
  "ewave-ubase::get-id", 
  "Gets the object id.", 
  obj, 
  ew_ubase, 
  rval,
  long)
{
  GFL_ASSERT_1(ew_ubase_get_id, obj);
  UBase *w = (UBase *) gh_cdr (obj);
  return gh_long2scm ((long)w->get_id ());
}

void ew_ubase_scheme_init ()
{
  GFL_NEW_TYPE (ew_ubase);
  GFL_NEW_PROCEDURE (ew_ubase_get_id);
  GFL_NEW_PROCEDURE (ew_ubase_set_id);
}
