#ifndef __BONES_H_
#define __BONES_H_

#include <ewave/objects/ew_object.h>
#include <ewave/vecmath.h>


class EW_Bone : public EW_Group
{	int size;
 public:
  EW_Bone();

  static EW_Class    klass;
  void               refresh () {}
  
  static void initialize();
  static void pdb_register(char *, long);

  static EW_Bone * scm2obj(SCM);
  static SCM obj2scm(EW_Object *);

  EW_bool uses_point (int);
  EW_bool select_point_down (int a, sgVec3 b);
  EW_bool select_point_drag (int a, sgVec3 b);
  EW_bool select_point_release (int a, sgVec3 b);
  EW_bool add_point_down (sgVec3 b);
  EW_bool add_point_drag (sgVec3 b);
  EW_bool add_point_release (sgVec3 b);

  void set_bone_dirty_bit(int);
  void set_draw_dirty_bit();
  void gl_draw();

  void translate(sgVec3);
  void lock (EW_bool);

  void write(FILE *, int);
  void update_gui();

  EW_Object * replicate();

  void update (double);
  void translate_point (sgVec3 & dst, sgVec3 & src);
  EW_int_array a;
  EW_int_array b;
  EW_bool t_bit;
  EW_bool d_bit;

  double rotation;
  sgMat4 object_rotation;

 protected:
  void rot(sgMat4 &);
  static EW_ObjectRecord record;
};

typedef EW_Bone *                 EW_Bone_ptr;

class EW_Bone_array : public EW_ptr_array 
{
public:
  EW_Bone_ptr & first() 
    { return (EW_Bone_ptr &)EW_array::first(); }
  EW_Bone_ptr & last() 
    { return (EW_Bone_ptr &)EW_array::last(); }
  EW_Bone_ptr & operator[](EW_int i) 
    { return (EW_Bone_ptr &)_data[i*_item_size]; }
  EW_Bone_ptr & append(EW_int s) 
    { return (EW_Bone_ptr &)EW_array::append(s); }
  EW_Bone_ptr & append() 
    { return append(1); }
  EW_Bone_ptr & insert(EW_int n, EW_int s) 
    { return (EW_Bone_ptr &)EW_array::insert(n, s); }
  EW_Bone_ptr * data() 
    { return (EW_Bone_ptr *)_data; }
};

extern EW_Bone_array bone_list;
extern int Frame;
extern EW_Bone *theCurrentBone;
extern int current_bone;
extern int bone_from_point (int);
extern int frame_count;
extern int current_frame;

#endif
