#ifndef _INCLUDE_CAMERA_H_
#define _INCLUDE_CAMERA_H_ 1

#include <ewave/objects/ew_object.h>

class EW_Camera : public EW_Object 
{
 public:

  EW_Camera ();

  virtual EW_Class&    vklass () { return klass; }
  static EW_Class      klass;

  static void          initialize ();
  EW_Object*           replicate();

  virtual void         refresh (); // update_gui
  
  Vec3                 get_look_at () { return get_coeff (center); }
  void                 set_look_at (Vec3 v);
  Vec3                 get_up () { return get_coeff (center); }
  void                 set_up (Vec3 v);

  short                select_point_down (Point a, Vec3 b);
  short                select_point_drag (Point a, Vec3 b);
  short                select_point_release (Point a, Vec3 b);
  short                add_point_down (Vec3 b);
  short                add_point_drag (Vec3 b);
  short                add_point_release (Vec3 b);
  EW_Object *          object_from_point (int);

  // Native Read and Write
  virtual int          write (EIFF *);
  virtual int          read (EIFF *);

  virtual void         draw (int, EW_Drw);
  
  int                  style;  // kind of camera projection
  int                  cylinder;
  double               angle;

  static EW_Camera *   first_camera (EW_Object * a);

 protected:
  Point                look_at;
  Point                up;
  static Mesh*         mesh;
};

#endif
