/* Extreme Wave -- A 3d modelling and animation environment
   Copyright (C) 1999 James Dean Palmer
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Please report all bugs and problems to "james@tiger-marmalade.com".
*/
#include <unistd.h>
#include "ew_generic.h"
//#include "ew_generic_gui.h"
// #include <ewave/objects/ew_generic_gui.fl>
#include <ewave/xpm_icons/box.xpm>

EW_Class EW_Generic::klass;

EW_Generic::EW_Generic () 
{
  radius = new_coeff ();
  scale  = new_coeff3 ();
  rotate = new_coeff3 ();

  set_coeff (radius, 5);
  set_coeff (scale,  Vec3 (1, 1, 1));
  set_coeff (rotate, Vec3 (0, 0, 0));
}

void
EW_Generic::initialize ()
{
  extern void ew_generic_scheme_init ();
  
  klass.name ("EW_Generic");
  klass.create (0);
  klass.pixmap (new Fl_Pixmap(box_xpm));
// BUG:  klass.inspector (make_ew_generic_gui ());
  ew_generic_scheme_init ();
}

void 
EW_Generic::refresh ()
{
// BUG:  refresh_ew_generic_gui (this);
}

void 
EW_Generic::translate (Vec3 a)
{
  // ...
}

int
EW_Generic::write (EIFF *eiff)
{
  EW_Object::write (eiff);
  eiff_write_long (eiff, 1);
    {
      eiff_write_long (eiff, radius);
      scale.write (eiff);
      rotate.write (eiff);
    }
  if (&klass == &vklass())
    eiff_finish_chunk (eiff);
  return 0;
}

int
EW_Generic::read (EIFF *eiff)
{
  EW_Object::read (eiff);
  long version = eiff_read_long (eiff);

  if (version >= 1)
    {
      radius = eiff_read_long (eiff);
      scale.read (eiff);
      rotate.read (eiff);
    }
  return 0;
}
