#ifndef _INCLUDE_EW_GENERIC_H_
#define _INCLUDE_EW_GENERIC_H_

#include <ewave/objects/ew_object.h>
#include <FL/Fl_Pack.H>

class EW_Generic : public EW_Object 
{
 public:
  EW_Generic ();

  static  EW_Class     klass;
  virtual EW_Class&    vklass () { return klass; }

  static void          initialize();

  virtual void         refresh ();

  /*
  virtual short        select_point_down (Point, Vec3);
  virtual short        select_point_drag (Point, Vec3);
  virtual short        select_point_release (Point, Vec3);
  virtual short        add_point_down (Vec3);
  virtual short        add_point_drag (Vec3);
  virtual short        add_point_release (Vec3);
   */
  
  Coeff3               get_scale_coeff () { return scale; }
  void                 set_scale_coeff (Coeff3 p) { scale = p; }
  Coeff3               get_rotate_coeff () { return rotate; }
  void                 set_rotate_coeff (Coeff3 p) { rotate = p; }
  long                 get_radius_coeff () { return radius; }
  void                 set_radius_coeff (long p) { radius = p; }
  
  // Set the scale coefficient to 2.
  // set_coeff (o->get_scale_coeff (), Vec3 (2, 2, 2));  -or-
  // set_coeff (o->scale, Vec3 (2, 2, 2));
  
  /*
  Vec3                 get_scale () { return coeff_get (scale); }
  void                 set_scale (Vec3 v) { coeff_set (scale, v); }
  Vec3                 get_rotate () { return coeff_get (rotate); }
  void                 set_rotate (Vec3 v) { coeff_set (rotate, v); }
  double               get_radius () { return coeff_get (radius); }
  void                 set_radius (double d) { coeff_set (radius, d); }
   */
  
  void                 translate (Vec3);
  
  // Native Read and Write
  virtual int          write (EIFF *);
  virtual int          read (EIFF *);

  //virtual void         draw(int, EW_Drw);

 protected:
  Point                scale;
  Point                rotate;
  long                 radius;
};

#include <FL/Fl_Input.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Choice.H>
#include "Fl_Frametab/Fl_Frametab.H"

class Fl_Generic_Xform : public Fl_Frametab {
 public:
  Fl_Generic_Xform(int x, int y, int w, int h, char *c = 0);
  Fl_Value_Input* scale_x;
  Fl_Value_Input* scale_y;
  Fl_Value_Input* scale_z;
  Fl_Value_Input* rotate_x;
  Fl_Value_Input* rotate_y;
  Fl_Value_Input* rotate_z;
  Fl_Value_Input* translate_x;
  Fl_Value_Input* translate_y;
  Fl_Value_Input* translate_z;
};

class Fl_Generic_Radius : public Fl_Frametab {
public:
  Fl_Generic_Radius(int x, int y, int w, int h, char *c = 0);
  Fl_Value_Input* value;
};

class Fl_Generic_Name : public Fl_Frametab {
public:
  Fl_Generic_Name(int x, int y, int w, int h, char *c = 0);
  Fl_Input* value;
};

class Fl_Generic_Material : public Fl_Frametab {
public:
  Fl_Generic_Material(int x, int y, int w, int h, char *c = 0);
  void update_material();
  Fl_Choice* value;
};

class Fl_Generic_Bone : public Fl_Frametab {
public:
  Fl_Generic_Bone(int x, int y, int w, int h, char *c = 0);
  void update_bone();
  Fl_Choice* value;
};

#endif
