#ifndef _INCLUDE_EW_GROUP_H_
#define _INCLUDE_EW_GROUP_H_

#include <ewave/objects/ew_object.h>

class EW_Group : public EW_Object 
{	const char* _name;
 public:

  EW_Group ();
  virtual ~EW_Group ();
  static void        initialize();
  
  virtual EW_Class&  vklass () { return klass; }
  virtual void       refresh (); // update_gui
  
  virtual short      is_group () { return 1; }
  virtual void       set_damage (EW_Dmg);
  virtual void       draw (int, EW_Drw);

  void               translate (Vec3);
  void               scale (Vec3, Vec3);
  void               rotate (Vec3, Vec3);
  
  void name(const char* name)
  {	this->_name=name;
  }

  EW_Object *        object_from_point (int);

  int                write (char*);
  virtual int        write (EIFF*);
  virtual int        read (EIFF*);

  EW_Object*         replicate();

  short              remove_child (EW_Object *);
  short              add (EW_Object *);
  short              clear ();

  long              get_open () { return open; }
  void               set_open (short o) { open = 0; }

  EW_Object_List     children;
  static EW_Class    klass;

 protected:
  long               open;
};

#endif
