#include <ewave/objects/ew_group.h>

/*
   1.  Smob handling functions:
*/

static SCM
Smark (SCM widget_smob)
{
  return SCM_BOOL_F;
}

static scm_sizet
Sfree (SCM smob)
{
  delete (EW_Object *) gh_cdr (smob);
  return (sizeof sizeof (EW_Group));
}

static int
Sprint (SCM smob, SCM port, scm_print_state *pstate)
{
  EW_Group *obj = (EW_Group *) gh_cdr (smob);
  scm_puts ("#<obj EW_Group ", port);
  scm_puts ((char *)obj->klass.name (), port);
  scm_puts (">", port);
  return 1;
}

/*
   2.  Smob definition:
*/

GFL_SUBCLASS_TYPE ("ewave-group", 
		   "The group class.",
		   ew_group, ew_object, 
		   Smark, Sfree, Sprint);

/*
   3.  Smob Methods:
*/

GFL_PROCEDURE_1_1
  ( ew_group_get_children,
   "ewave-group::get-children",
   "Gets the groups children.",
   obj,
   ew_group,
   children,
   int ) // bogus - this is a list - FIXME
{
  GFL_ASSERT_1 (ew_group_get_children, obj);
  EW_Group * s = (EW_Group *) gh_cdr (obj);
  SCM smob = SCM_EOL;
  for (EW_Object_List::cursor i = s->children.begin (); i.value (); i++)
    {
      SCM child;
      GFL_NEW_SMOB (ew_group, child, (&i));
      smob = gh_cons (child, smob);
    }
  return smob;
}

void ew_group_scheme_init ()
{
  GFL_NEW_TYPE (ew_group);
  GFL_NEW_PROCEDURE (ew_group_get_children);
  printf ("ew_group_class_tag = %ld\n", ew_group_class_tag.tag);
}

