#ifndef _INCLUDE_LIGHT_H_
#define _INCLUDE_LIGHT_H_

#include <ewave/objects/ew_object.h>

class EW_Light : public EW_Object 
{
 public:
void EW_Light::update_gui();

  EW_Light();

  virtual EW_Class&  klass () { return klass_; }
  virtual void       refresh (); // update_gui
  
  static void        initialize();
  static void        pdb_register(char *, long);
  static EW_Light*   scm2obj(SCM);
  static SCM         obj2scm(EW_Object *);

//  EW_Vec3            look_at () { return coeff.get (center_); }
  void               look_at (EW_Vec3 v);

  EW_bool            uses_point (int a);
  EW_bool            select_point_down (int a, EW_Vec3 b);
  EW_bool            select_point_drag (int a, EW_Vec3 b);
  EW_bool            select_point_release (int a, EW_Vec3 b);
  EW_bool            add_point_down (EW_Vec3 b);
  EW_bool            add_point_drag (EW_Vec3 b);
  EW_bool            add_point_release (EW_Vec3 b);

  void               write(FILE *, int);
  void               write_class (FILE *, int);

  EW_Object*         replicate();
  void               gl_draw();
  
  sgVec3 diffuse;
  int style;  // kind of EW_Light source
  EW_bool atmospheric_attenuation;
  double fade_distance;
  double fade_power;
  EW_bool shadowless;
  // Used for spotEW_Lights and cylindrical lights:
  double radius;
  double falloff;
  double tightness;

 protected:
  static EW_Class    klass_;
  EW_Point look_at_;

};

extern EW_Object_array light_array;

#endif
