// Extreme Wave -- A 3d modelling and animation environment
// Copyright (C) 1999 James Dean Palmer
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// Please report all bugs and problems to "james@tiger-marmalade.com".

#include <unistd.h>
#include <stdio.h>
#include <FL/fl_draw.H>
#include <GL/gl.h>
//#include <GL/glu.h>
#include <FL/fl_ask.H>
#include <FL/fl_show_colormap.H>

#include <ewave/gui/gui.h>
#include <ewave/objects/grid.h>

Grid_List JGrid;

void UpdateBrowser () 
{
  int j;
  j = GridBrowser->value();
  GridBrowser->clear();
  for (unsigned long i=0; i<JGrid.size(); i++) 
    {
      GridBrowser->add(JGrid[i].name);   
    }
  GridBrowser->value(j);
}

void GridBrowserClear () 
{
  TGrid a;
  a.name = strdup("(x-z) 10x10");
  a.w = 10.0;
  a.h = 10.0;
  a.uoff = 0.0;
  a.voff = 0.0;
  a.umax = 50.0;
  a.vmax = 50.0;
  a.umin = -50.0;
  a.vmin = -50.0;
  a.visible = 1;
  a.color = 44;
  a.ux = 1.0;
  a.uy = 0.0;
  a.uz = 0.0;
  a.vx = 0.0;
  a.vy = 0.0;
  a.vz = 1.0;
  a.woff = 0.0;
  JGrid.clear();
  JGrid.push_back(a);
  a.name = strdup("(x-y) 10x10");
  a.w = 50.0;
  a.h = 50.0;
  a.uoff = 0.0;
  a.voff = 0.0;
  a.umax = 50.0;
  a.vmax = 50.0;
  a.umin = -50.0;
  a.vmin = -50.0;
  a.visible = 1;
  a.color = 42;
  a.ux = 1.0;
  a.uy = 0.0;
  a.uz = 0.0;
  a.vx = 0.0;
  a.vy = 0.0;
  a.vz = 1.0;
  a.woff = 0.0;
  JGrid.push_back (a);
  a.name = strdup("(x-z) 10x10");
  a.w = 10.0;
  a.h = 10.0;
  a.uoff = 0.0;
  a.voff = 0.0;
  a.umax = 50.0;
  a.vmax = 50.0;
  a.umin = -50.0;
  a.vmin = -50.0;
  a.visible = 1;
  a.color = 140;
  a.ux = 1.0;
  a.uy = 0.0;
  a.uz = 0.0;
  a.vx = 0.0;
  a.vy = 1.0;
  a.vz = 0.0;
  a.woff = 0.0;
  JGrid.push_back (a);
  UpdateBrowser();
  GridConfigurationWriteFields(GridBrowser, NULL);
}

void GridBrowserDuplicateSelect(Fl_Button* a, void* b) 
{
  int i;
  i = GridBrowser->value() - 1;
  if (i<=0) i=0;
  JGrid.push_back (JGrid[i]);
  UpdateBrowser();
  GridConfigurationWriteFields(GridBrowser, NULL);
}

void GridBrowserRemoveSelect(Fl_Button* a, void* b) 
{
  unsigned long i = 0;
  if (JGrid.size() <= 1) 
    {
      fl_alert("Sorry, you must have at least one grid value.");
      return;
    }
  if (GridBrowser->value() > 1)
    i = GridBrowser->value() - 1;
  
  JGrid.erase (i);

  UpdateBrowser();
  GridConfigurationWriteFields(GridBrowser, NULL);
}

void GridConfigurationWriteFields (Fl_Browser* a, void* b) 
{
  int i, j;
  char s[30];
  j = GridBrowser->value();
  i=j-1;
  if (i<=0) i=0;
  GridName->value(JGrid[i].name);
  if (JGrid[i].visible) GridVisible->value(1);
  else GridVisible->value(0);
  
  sprintf(s, "%g", JGrid[i].w); GridW->value(s);
  sprintf(s, "%g", JGrid[i].h); GridH->value(s);
  sprintf(s, "%g", JGrid[i].uoff); GridUOff->value(s);
  sprintf(s, "%g", JGrid[i].voff); GridVOff->value(s);
  sprintf(s, "%g", JGrid[i].vmax); GridVMax->value(s);
  sprintf(s, "%g", JGrid[i].umax); GridUMax->value(s);
  sprintf(s, "%g", JGrid[i].vmin); GridVMin->value(s);
  sprintf(s, "%g", JGrid[i].umin); GridUMin->value(s);
  sprintf(s, "%g", JGrid[i].ux); GridUX->value(s);
  sprintf(s, "%g", JGrid[i].uy); GridUY->value(s);
  sprintf(s, "%g", JGrid[i].uz); GridUZ->value(s);
  sprintf(s, "%g", JGrid[i].vx); GridVX->value(s);
  sprintf(s, "%g", JGrid[i].vy); GridVY->value(s);
  sprintf(s, "%g", JGrid[i].vz); GridVZ->value(s);
  
  GridColor->color(JGrid[i].color);
  GridColor->redraw();
  
  //   GridBrowser->value(j);
}

void GridConfigurationReadFields2 (Fl_Light_Button*, void*) 
{
  GridConfigurationReadFields(NULL, NULL);
}

void GridConfigurationReadFields (Fl_Input* a, void* b) 
{
  int i;
  i = GridBrowser->value() - 1;
  if (i<=0) i=0;
  
  if (GridVisible->value()) JGrid[i].visible=1;
  else JGrid[i].visible=0;
  
  if (JGrid[i].name) free(JGrid[i].name);
  JGrid[i].name = strdup(GridName->value());
  JGrid[i].w = atof(GridW->value());
  JGrid[i].h = atof(GridH->value());
  JGrid[i].uoff = atof(GridUOff->value());
  JGrid[i].voff = atof(GridVOff->value());
  JGrid[i].vmax = atof(GridVMax->value());
  JGrid[i].umax = atof(GridUMax->value());
  JGrid[i].vmin = atof(GridVMin->value());
  JGrid[i].umin = atof(GridUMin->value());
  
  JGrid[i].ux = atof(GridUX->value());
  JGrid[i].uy = atof(GridUY->value());
  JGrid[i].uz = atof(GridUZ->value());
  JGrid[i].vx = atof(GridVX->value());
  JGrid[i].vy = atof(GridVY->value());
  JGrid[i].vz = atof(GridVZ->value());
  JGrid[i].woff = atof(GridWOff->value());
  JGrid[i].color = GridColor->color();
  UpdateBrowser();
}

void GridBrowserShiftDownSelect(Fl_Button* a, void* b) 
{
  int i;
  unsigned long j;
  TGrid c;
  if (JGrid.size() <= 1) return;
  i = GridBrowser->value() - 1;
  if (i<=0) i=0;
  j = i + 1;
  
  if (j >= JGrid.size()) return;
  c = JGrid[i];
  JGrid[i] = JGrid[j];
  JGrid[j] = c;
  
  UpdateBrowser();
  GridBrowser->value((j+1));
}

void GridBrowserShiftUpSelect(Fl_Button* a, void* b) 
{
  int i, j;
  TGrid c;
  if (JGrid.size() <= 1) return;
  i = GridBrowser->value() - 1;
  if (i<=0) i=0;
  j = i - 1;
  
  if (j<0) return;
  c = JGrid[i];
  JGrid[i] = JGrid[j];
  JGrid[j] = c;
  
  UpdateBrowser();
  GridBrowser->value((j+1));
}

void GridOkaySelect(Fl_Return_Button*, void*) 
{
  grid_inspector->hide();
}

void GridColorSelect(Fl_Button*, void*) 
{
  uchar i;
  i = fl_show_colormap(GridColor->color());
  GridColor->color(i);
  GridColor->redraw();
  GridConfigurationReadFields(NULL, NULL);
}

void draw_grid() 
{
  for (unsigned long a=0; a<JGrid.size(); a++) 
    {
      uchar r,g,b;
      double rr,gg,bb;
      Fl::get_color((Fl_Color)JGrid[a].color, r, g, b);
      rr=(double)r;
      rr=rr/255.0;
      gg=(double)g;
      gg=gg/255.0;
      bb=(double)b;
      bb=bb/255.0;
      
      glColor3f(rr, gg, bb);
      glBegin(GL_LINES);
      // addme = (u . v) * woff
      // Draw U Lines
      if (JGrid[a].visible) {
	// This can be sped up my taking some of the multiplications
	// out of these for-loops.
	double j;
	for (j=JGrid[a].umin; j<=JGrid[a].umax; j=j+JGrid[a].w) {
	  glVertex3f( (JGrid[a].ux)*j+JGrid[a].vx*(JGrid[a].vmax), 
		     (JGrid[a].uy)*j+JGrid[a].vy*(JGrid[a].vmax), 
		     (JGrid[a].uz)*j+JGrid[a].vz*(JGrid[a].vmax));
	  glVertex3f( (JGrid[a].ux)*j+JGrid[a].vx*JGrid[a].vmin, 
		     (JGrid[a].uy)*j+JGrid[a].vy*JGrid[a].vmin, 
		     (JGrid[a].uz)*j+JGrid[a].vz*JGrid[a].vmin);
	}
	for (j=JGrid[a].vmin; j<=JGrid[a].vmax; j=j+JGrid[a].h) {
	  glVertex3f( (JGrid[a].vx)*j+JGrid[a].ux*(JGrid[a].umax), 
		     (JGrid[a].vy)*j+JGrid[a].uy*(JGrid[a].umax), 
		     (JGrid[a].vz)*j+JGrid[a].uz*(JGrid[a].umax));
	  glVertex3f( (JGrid[a].vx)*j+JGrid[a].ux*JGrid[a].umin, 
		     (JGrid[a].vy)*j+JGrid[a].uy*JGrid[a].umin, 
		     (JGrid[a].vz)*j+JGrid[a].uz*JGrid[a].umin);
	   }
      }
      glEnd();
    }
}
