#!/usr/bin/perl -w
# Move FLTK.org files into CinePaint's FLTK directory layout
# rsr 2/2/06
use strict;

#my $mode = 'setup'; 
my $mode = 'reorg'; 
#my $mode = 'undo'; 

my @dirs = qw(mac win32 x11 unused);
my $file_list = qw(fltk-reorg.txt);

sub MakeFileList()
{	print("Creating move list $file_list");
	open (my $OS,'>',$file_list) or die("can't open $file_list");
	foreach my $dir (@dirs)
	{	print("dir=$dir\n");
		opendir(my $DIR, "src/$dir");
		my @files = grep(/\.cxx$/,readdir($DIR));
		closedir($DIR);
		foreach my $file (@files) 
		{	print($OS,"src/$file src/$dir/$file\n");
	}	}
	close($OS);
}

sub MoveFiles()
{	if($mode eq 'undo')
	{	print("Moving FLTK files back into FLTK locations\n");
	}
	else
	{	print("Moving FLTK files into CinePaint locations\n");
	}
	open (my $INPUT,'<',$file_list) or die("can't open $file_list");
	my @input=<$INPUT>;
	close($INPUT);
	foreach my $line (@input)
	{	chomp($line);
		#print("($line)\n");
		my @word=split(/ / ,$line);
		if($word[0] eq "mkdir")
		{	print "mkdir $word[1]\n";
			if(!mkdir($word[1],0755))
			{	print "skipping...\n";
			}
			next;
		}
		if($mode eq 'undo')
		{	($word[0],$word[1])=($word[1],$word[0]);
		}
		if(rename($word[0],$word[1]))
		{	print "renaming $word[0] --> $word[1]\n";
		}
		else
		{	print "skipping $word[0] --> $word[1]\n";
}	}	}

sub main()
{	if($mode eq 'setup')
	{	MakeFileList();
		return;
	}
	MoveFiles();
}

main();
