// Cstring_t.h
// rsr 11/13/06

#ifndef CSTRING_H
#define CSTRING_H

#include <string.h>

namespace gel {

template <class T>
struct Cstring_t
{	T* data;
	void Reset()
	{	data=0;
	}
	Cstring_t<T>(T* data)
	:	data(data)
	{}
	Cstring_t<T>(const T* data)
	:	data((T*)data)
	{}
	Cstring_t<T>(Cstring_t<T>& ss)
	:	data(ss.data)
	{}
	void Set(T* string)
	{	if(!string)
		{	Reset();
			return;
		}
		data=string;
	}
	bool IsGood() const
	{	return 0!=data;
	}
	bool IsEqual(const Cstring_t<T>& b) const
	{	if(!IsGood() && !b.IsGood())
		{	return true;
		}
		if(!IsGood() || !b.IsGood())
		{	return false;
		}
		if(!strcmp(data,b.data))
		{	return true;
		}
		return false;
	}
	unsigned GetLength() const
	{	return IsGood()? strlen(data):0;
	}
	T* Find(T c)
	{	return data? (T*) strchr(data,c):0;
	}
	Cstring_t<T> operator=(Cstring_t<T>& rh)
	{	return Cstring_t<T>(rh);
	}
	operator const char*()
	{	return data;
	}
};

} //namespace

typedef gel::Cstring_t<char> Cstring;
typedef gel::Cstring_t<unsigned> BCstring;

template <class T>
bool operator==(const gel::Cstring_t<T>& lh,const gel::Cstring_t<T>& rh)
{	return lh.IsEqual(rh);
}

template <class T>
bool operator==(const gel::Cstring_t<T>& lh,const char* s)
{	const gel::Cstring_t<T> rh(s);
	return lh.IsEqual(rh);
}

#	ifdef IO_FILE_H

template <class T>
gel::IoFile& Write(gel::IoFile& os,const gel::Cstring_t<T>& ss)
{	if(ss.IsGood())
	{	const size_t bytes=fwrite(ss.data,sizeof(char),ss.length,os.file);
	}
	return os;
}

template <class T>
bool operator==(gel::Cstring_t<T>& a,gel::Cstring_t<T>& b)
{	return a.IsEqual(b);
}

#	endif

#endif
