// SubstringField.h
// rsr 7/19/06

#ifndef SUBSTRING_FIELD_H
#define SUBSTRING_FIELD_H

#include "Substring.h"

namespace gel {

class SubstringField
{	const char sep;
public:
	Substring name;
	Substring value;
	SubstringField(const char* string,char sep='=')
	:	sep(sep)
	{	if(!string || !*string)
		{	return;
		}
		const char* boundary=strchr(string,sep);
		if(!boundary)
		{	return;
		}
		name.data=(char*)string;
		name.length=boundary-string;
		value.data=(char*)boundary+1;
		value.length=strlen(value.data);
	}
	bool IsName(const char* fieldname) const
	{	if(!name.data || !fieldname || !*fieldname)
		{	return false;
		}
		return name==fieldname;
	}
	bool IsData(const char* fielddata) const
	{	if(!name.data || !fielddata)
		{	return false;
		}
		return value==fielddata;
	}
	const char* GetData()
	{	return value.data;
	}
	bool operator!() const
	{	return !name;
	}
};

}

#endif
