// Tokenizer.h 10/10/04
// Copyright 2004 Robin.Rowe@MovieEditor.com
// License OSI MIT

#ifndef TOKENIZER_H
#define TOKENIZER_H

#error obsolete, use Substring

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "Substring.h"

/*
#ifdef WIN32
#include <winsock2.h>
#include <windows.h>
#include <windef.h>
#else
#define BYTE unsigned char
#endif
*/

namespace gel {

inline
bool ReadNumber(const char* string,unsigned* number)
{	const int field_count=sscanf(string,"%u",number);
	return 1==field_count;
}

inline
const char* GetEnd(const char* string)
{	return string? string+strlen(string):0;
}

inline
const char* GetEndOfLine(const char* string)
{	if(!string)
	{	return 0;
	}
	const char* ptr=strchr(string,'\n');
	if(ptr)
	{	return ptr;
	}
	return GetEnd(string);
}

const char* SkipWhitespace(const char* string,const char* end);
const char* SkipDarkspace(const char* string,const char* end);

class Tokenizer
{	const char field_sep;
	const char* data;
	const char* end_of_data;
	const char* ptr;
//	const char* end_of_word;
//	const char* end_of_line;
/*	bool SkipDarkspace()
	{	const char* ptr=gel::SkipDarkspace(data,end_of_word);
		if(!ptr)
		{	return false;
		}
		data=ptr;
		return true;
	}*/
	bool GetFirstWord()
	{	SkipWhitespace();
		end_of_word=gel::SkipDarkspace(data,end_of_data);
		return data!=end_of_data;
	}
public:
/*	Tokenizer()
	:	field_sep('=')
	{	data=0;
		end_of_word=0;
		end_of_line=0;
		end_of_data=0;
	}*/
	Tokenizer(const char* string)
	:	field_sep('=')
	{	Reset();
		data=string;
		end_of_data=GetEnd(string);
//		end_of_line=GetEndOfLine(string);
	}
	Tokenizer(const char* string,unsigned length)
	:	field_sep('=')
	{	Reset();
		data=string;
		end_of_data=data+length;
	}
	Tokenizer(const unsigned char* string,unsigned length)
	:	field_sep('=')
	{	Reset();
		data=(const char*)string;
		end_of_data=data+length;
	}
	void Reset()
	{	ptr=data;
		end_of_word=0;
	}
	char Peek(unsigned offset) const
	{	if(offset+data>end_of_data)
		{	return 0;
		}
		return data[offset];
	}
	bool ToNextWord()
	{	if(end_of_word)
		{	data=end_of_word;
		}
		return GetFirstWord();
	}
	bool ToNextField()
	{	return GetNextWord();
	}
	bool ToNextLine()
	{	const char* endline=(const char*)memchr((const void*)data,'\n',end_of_data-data);
		if(endline)
		{	data=endline+1;
			return true;
		}
		return false;
	}
	Substring GetLine() const
	{	end_of_line=strchr(data,'\n');
		if(!end_of_line)
		{	end_of_line=end_of_data;
		}
		return Substring(data,end_of_data);
	}
/*	bool IsField(const char* fieldname) const
	{	if(!fieldname || !*fieldname)
		{	return false;
		}
		const size_t len=strlen(fieldname);
		const int is_different=strncmp(data,fieldname,len);
		if(is_different)
		{	return false;
		}
		return field_sep==data[len];
	}
	bool IsEqual(const char* fielddata) const
	{	if(!fielddata)
		{	return false;
		}
		const size_t len=strlen(fielddata);
		const char* ptr=(const char*)memchr(data,field_sep,end_of_word-data);
		if(!ptr)
		{	return false;
		}
		const int is_different=strncmp(data,fielddata,len);
		if(is_different)
		{	return false;
		}
		return ptr+len==end_of_word;
	}*/
	const char* GetData() const
	{	return data;
	}
	bool SkipWhitespace()
	{	const char* ptr=gel::SkipWhitespace(data,end_of_word);
		if(!ptr)
		{	return false;
		}
		data=ptr;
		return true;
	}
};

}

#endif