/* dl_list.h
// Doubly-linked node for linked list support
// Copyright May 25, 2003, Robin.Rowe@MovieEditor.com
// License MIT (http://opensource.org/licenses/mit-license.php)
*/

#ifndef DL_LIST_H
#define DL_LIST_H

#include "Node.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct DL_list DL_list;
typedef struct DL_node_iterator DL_node_iterator;

struct DL_list
{	Node* head;
	Node* tail;
#ifdef _DEBUG
	int count;
#endif
};

struct DL_node_iterator
{	Node* it;
};

int DL_is_used_node(DL_list* dl_list,Node* node);
void DL_append(DL_list* dl_list,Node* node);
void DL_remove(DL_list* dl_list,Node* node);
int DL_is_empty(DL_list* dl_list);
void* DL_GetNode(DL_list* dl_list,unsigned n);
void DL_VerifyNodeInList(DL_list* dl_list,Node* node);

inline
int DL_is_used_node(DL_list* dl_list,Node* node)
{	return ((dl_list->head==node) || (0!=node->prev));
}

inline
int DL_is_empty(DL_list* dl_list)
{	return 0==dl_list->head;
}

#define MacroGetTypedNode(type)\
inline\
type* GET_##type(DL_list* dl_list,unsigned n)\
{	if(!dl_list)\
	{	return 0;\
	}\
	return (type*) DL_GetNode(dl_list,n);\
}

#ifdef __cplusplus
}
#endif

#endif

