/* dl_list_iterator.h
// Doubly-linked node for linked list support
// Copyright June 27, 2006, Robin.Rowe@MovieEditor.com
// License MIT (http://opensource.org/licenses/mit-license.php)
*/

#ifndef DL_LIST_ITERATOR_H
#define DL_LIST_ITERATOR_H

#include "dl_list.h"

template <class T>
class DL_list_iterator
{	DL_node* node;
public:
	DL_list_iterator(DL_list* list)
	{	node=0;
		if(list)
		{	node=list->head;
	}	}
	DL_list_iterator(DL_node* node)
	{	this->node=node;
	}
	T* Next()
	{	return (T*) NextNode();
	}
	T* Prior()
	{	return (T*) PriorNode();
	}
	DL_node* NextNode()
	{	if(!node)
		{	return 0;
		}
		DL_node* before=node;
		node=node->next;
		return before;
	}
	DL_node* PriorNode()
	{	if(!node)
		{	return 0;
		}
		DL_node* before=node;
		node=node->prev;
		return before;
}	};
	
#endif

