// IoFileBuffer.h 12/25/04
// Copyright 2004 Robin.Rowe@MovieEditor.com
// License OSI MIT

#ifndef IO_FILE_BUFFER_H
#define IO_FILE_BUFFER_H

#include "IoFile.h"
#include "../data/Buffer.h"
#include "../data/ErrorString.h"

namespace gel {

template <class T>
class IoFileBuffer 
{	
public:
	IoFile file;
	Buffer<T> buffer;
	ErrorString error_msg;
	bool Create(const char* filename,unsigned pad=32*1024)
	{	if(!file.Open(filename,"w+b"))
		{	error_msg="couldn't open file";
			return false;
		}
		if(!buffer.Open(pad))
		{	error_msg="couldn't open buffer";
			return false;
		}
		buffer.Truncate();
		return true;
	}
	bool OpenAndRead(const char* filename,unsigned pad=0)
	{	unsigned long file_size=GetFileSize(filename);
		if(0==file_size)
		{	error_msg="file size = 0";
			return false;
		}
		if(!buffer.Open(file_size+pad+1))
		{	error_msg="insufficient memory";
			return false;
		}
		IoFile file;
		if(!file.Open(filename))
		{	error_msg="can't open";
			return false;
		}
		T* ptr=buffer.GetUnsafeData();
		if(!file.Read(ptr,file_size))
		{	error_msg="can't read";
			return false;
		}
		return true;	
	}
};

} // namespace

#endif
