/* libcinepaint/dll_api.h 3/8/03
// Copyright 2003 Robin.Rowe@MovieEditor.com
// License OSI MIT
// Windows DLL export/import macro
*/

#ifdef WIN32

#ifdef DLL_EXPORTS
#define DLL_API __declspec(dllexport)
#define DLL_C_API extern "C" __declspec(dllexport)
#else
#define DLL_API __declspec(dllimport)
#define DLL_C_API extern "C" __declspec(dllimport) 
#endif

#else

#define DLL_API 
#define DLL_C_API 

#endif

/* Using DLL_C_API ensures everywhere a function is declared and defined 
makes sure it is the one and only C linkage undecorated version, that you 
can't inadvertently overload it by giving different function arguments 
where you intended just one function. Note that in general to have 
decorated C++ functions as DLL entries is evil, has weird signatures.

For debugging DLL linkage problems in VC++ use a batch file like this:

 dumpbin img_ppm.dll /IMPORTS /EXPORTS /out:dumpbin.txt
 pause

With VC7 you will need these files accessible to this batch file:

dumpbin.exe
link.exe
mspdb71.dll

The output of dumpbin will look like this:

 Dump of file img_ppm.dll

 File Type: DLL

  Section contains the following exports for img_ppm.dll

    00000000 characteristics
    45609462 time date stamp Sun Nov 19 09:29:06 2006
        0.00 version
           1 ordinal base
           3 number of functions
           3 number of names

    ordinal hint RVA      name

          1    0 00002E50 ImgGetInfo
          2    1 00002990 ImgReadFile
          3    2 00002D00 ImgWriteFile

Note that the exports are undecorated C signatures, as they should be.

*/
