// Unsigned_t.cpp
// Robin.Rowe@MovieEditor.com 4/12/01

#include <ctype.h>
#include "../data/Number.h"

using namespace gel;

void Unsigned_t::FromSubstring(Substring s)
{	is_good=true;
	number=0;
	int mult=1;
	for(int i=s.length-1;i>=0;i--)
	{	const char c=s.data[i];
		if(!isdigit(c))
		{	if(!isspace((unsigned char)c))
			{	is_good=false;
				return;
			}
			return;
		}
		const unsigned digit=c-'0';
		if(digit)
		{	number+=digit*mult;
		}
		mult*=10;
}	}

char* gel::SkipWhitespace(char* string,char* end)
{	while(isspace((unsigned char)*string) && string<end)
	{	string++;
	}
	return string;
}

char* gel::SkipWhitespaceReverse(char* string,char* end)
{	end--;// pointing to char(0) or garbage
	while(isspace((unsigned char)*end) && string<end)
	{	end--;
	}
	return end+1;
}

char* gel::SkipDarkspace(char* string,char* end)
{	while(!isspace((unsigned char)*string) && string<end)
	{	string++;
	}
	return string;
}

const char* gel::SkipWhitespace(const char* string,const char* end)
{	while(isspace((unsigned char)*string) && string<end)
	{	string++;
	}
	return string;
}

const char* gel::SkipDarkspace(const char* string,const char* end)
{	while(!isspace((unsigned char)*string) && string<end)
	{	string++;
	}
	return string;
}

/*
bool Integer_t::FromSubstring(Substring s)
{	is_good=false;
	number=0;
	int mult=1;
	for(int i=s.length-1;i>=0;i--)
	{	const char c=s.data[i];
		if(!isdigit(c))
		{	if(number && '-'==c)
			{	number=-number;
				return (is_good=true);
			}
			return isspace((unsigned char)c)? (is_good=true):false;
		}
		const unsigned digit=c-'0';
		if(digit)
		{	number+=digit*mult;
		}
		mult*=10;
	}
	return (is_good=true);
}
*/

/*

bool Unsigned_t::GetMilleseconds(const char* string)
{	unsigned length=CountDigits(string);
	if(!length)
	{	return false;
	}
	if(!FromString(string,length))
	{	return false;
	}
	number*=1000;
	string+=length;
	if('.'!=string[0])
	{	return true;
	}
	string++;
	length=CountDigits(string);
	if(!length)
	{	return true;
	}
	const int temp=number;
	if(!FromString(string,length))
	{	return false;
	}
	number+=temp;
	return true;
}

bool Unsigned_t::GetAnyNumber(const char* string)
{	string=SkipNonDigits(string);
	const unsigned length=CountDigits(string);
	if(!length)
	{	return false;
	}
	return FromString(string,length);
}

const char* SkipNonDigits(const char* string) 
{	char c=*string;
	while(c)
	{	if(isdigit(c))
		{	return string;
		}
		string++;
		c=*string;
	}
	return string;
}

unsigned CountDigits(const char* string) 
{	char c=*string;
	unsigned count=0;
	while(c)
	{	if(!isdigit(c))
		{	return count;
		}	
		count++;
		string++;
		c=*string;
	}
	return count;
}

bool Unsigned_t::ToString(char* buffer,int width)
{	if(!buffer)
	{	return false;
	}
	int n=number;
	const bool is_negative=(n<0);
	if(is_negative)
	{	n=-n;
	}
	for(int i=width-1;i>=0;i--)
	{	const int mod=n%10;
		buffer[i]=mod+'0';
		n/=10;
		if(!n)
		{	i--;
			break;
	}	}
	char fill='0';
	if(i>=0 && is_negative)
	{	buffer[i]='-';
		i--;
		fill=' ';
	}
	Fill(buffer,fill,i+1);
	return 0==n;
}

*/
