/* wire/dl_list.cpp
// Doubly-linked node for linked list support
// Copyright May 25, 2003, Robin.Rowe@MovieEditor.com
// License MIT (http://opensource.org/licenses/mit-license.php)
*/

#include "../data/dl_list.h"

//#ifdef _DEBUG
//#define CHECK(node) if(node->is_trashed) __asm int 3
//#else
#define CHECK(node) 
//#endif

void DL_append(DL_list* dl_list,Node* node)
{	bzero(node);
	CHECK(node);
#ifdef _DEBUG
	dl_list->count++;
#endif
	if(DL_is_empty(dl_list))
	{	dl_list->head=dl_list->tail=node;
		return;
	}
	node->prev=dl_list->tail;
	if(dl_list->tail)
	{	dl_list->tail->next=node;
	}
	dl_list->tail=node;
}

void DL_remove(DL_list* dl_list,Node* node)
{	CHECK(node);
#ifdef _DEBUG
	dl_list->count--;
	DL_VerifyNodeInList(dl_list,node);
#endif
	/* If last node in list, empty list: */
	if(dl_list->tail==dl_list->head)
	{	dl_list->tail=dl_list->head=0;
		return;/* next and prev already 0 */
	}
	/* Check head and tail: */
	if(dl_list->head==node)
	{	dl_list->head=node->next;
	}
	if(dl_list->tail==node)
	{	dl_list->tail=node->prev;
	}
	/* Unlink node from chain: */
	if(node->prev)
	{	node->prev->next=node->next;
	}
	if(node->next)
	{	node->next->prev=node->prev;
	}
	/* Clear node pointers: */
	bzero(node);
}

void* DL_GetNode(DL_list* dl_list,unsigned n)
{	unsigned i;
	Node* node=dl_list->head;
	for(i=0;i<n;i++)
	{	if(!node)
		{	return 0;
		}
		node=node->next;
	}
	return node;
}

void DL_VerifyNodeInList(DL_list* dl_list,Node* node)
{	Node* next=dl_list->head;
	while(next)
	{	CHECK(node);
		if(node==next)
		{	return;
		}
		next=next->next;
	}
#ifdef WIN32
	__asm int 3;
#endif
}
