// cppstring.h 9/20/04
// Copyright 2004 Robin.Rowe@MovieEditor.com
// License OSI MIT

#ifndef CPP_STRING_H
#define CPP_STRING_H

#include <string.h>

class string
{	char* data;
	unsigned size;
	bool Open(const unsigned size)
	{	this->size=size;
		data=new char[size];
		return 0!=data;
	}
	void Close()
	{	delete[] data;
		Zero();
	}
	void Zero()
	{	data=0;
		size=0;
	}
public:
	~string()
	{	Close();
	}
	string()
	{	Zero();
	}
	string(const char* c)
	{	Zero();
		assign(c);
	}
	string(const string& s)
	{	Zero();
		assign(s.c_str());
	}
	bool assign(const char* c)
	{	Close();
		if(!c)
		{	return false;
		}
		const size_t len=strlen(c);
		if(!Open(len+1))
		{	return false;
		}
		strcpy(data,c);
		return true;
	}
	operator const char*() const
	{	return c_str();
	}
	bool empty() const
	{	return 0==data || 0==*data;
	}
	const char* c_str() const
	{	return data ? data:"";
	}
	void clear()
	{	Close();
	}
	string& operator=(const char* c)
	{	assign(c);
		return *this;
	}
	string& operator=(const string& s)
	{	assign(s.c_str());
		return *this;
	}
	bool operator==(const char* c) const
	{	if(!c ||!data)
		{	return false;
		}
		return !strcmp(c,data);
	}
};


#endif
