/* sched.h 
   Copyright 8-14-04 Robin.Rowe@movieeditor.com
   MIT OSI license
*/

#ifndef SCHED_H
#define SCHED_H

#include <setjmp.h>
#include <signal.h>
#include "pthread.h"

/* inline is C++ only */
#ifndef inline
#define inline __inline
#endif

typedef jmp_buf sigjmp_buf;
typedef int sigset_t;

#define SIG_BLOCK 0
/* Union of the current mask and set */
#define SIG_UNBLOCK 1
/* Intersection of the current mask and the complement of set */
#define SIG_SETMASK 2
/* set */

struct  sigaction {
	union {
		void    (*__sa_handler)(int);
		void    (*__sa_sigaction)(int, struct __siginfo *, void *);
	} __sigaction_u;		     /* signal handler */
	int     sa_flags;		     /* see signal options below */
	sigset_t sa_mask;		     /* signal mask to apply */
};

#if 1

#define sa_handler	     __sigaction_u.__sa_handler
#define sa_sigaction    __sigaction_u.__sa_sigaction

int sched_yield();
int __sigjmp_save (sigjmp_buf env, int savemask);

int sigsetjmp(sigjmp_buf env,int savesigs);

/*#define sigsetjmp(env,savesigs) __sigjmp_save(env,savesigs); setjmp(env) */

int sigemptyset(sigset_t *set);
int sigfillset(sigset_t *set);
int sigaddset(sigset_t *set, int signum);
int sigdelset(sigset_t *set, int signum);
int sigismember(const sigset_t *set, int signum); 
int sigsuspend(const sigset_t *sigmask);
int sigwait(const sigset_t *set, int *sig);
int sigaction(int sig, const struct sigaction* act,struct sigaction* oact);
int sigprocmask(int how, const sigset_t *set, sigset_t *oset);
int pthread_sigmask(int how, const sigset_t *set, sigset_t *oset);

#endif

#endif
