import net.sourceforge.mlt.*;

public class Play {

	static {
		System.loadLibrary("mlt_java");
	}

	public static void main (String[] args) {

		// Start the mlt system
		mlt.factory_init();

		// Create the producer
		MltProducer p = new MltProducer( args[0], null );

		if (p.is_valid() != 0) {
	  
			p.set ("eof", "loop");
	  
			// Create the consumer
			MltConsumer c = new MltConsumer ("sdl", null);

			// Turn off the default rescaling
			c.set("rescale", "none");
	
			// Connect the producer to the consumer
			c.connect(p);
	
			// Start the consumer
			c.start();

			// Wait until the user stops the consumer
			Object o = new Object();
			while (c.is_stopped() == 0) {
				synchronized (o) {
					try {
						o.wait(1000);
					} catch (InterruptedException e) {
						// ignored
					}
				}
			}

			// Stop it anyway
			c.stop();

			// Close the consumer
			c.destroy();

			// Close the producer
			p.destroy();
		} else {
			System.out.println ("Unable to open " + args[0]);
		}

		// Close the factory
		mlt.factory_close();
	}
}
