#!/bin/env perl

# Import required modules
use mlt;

# Start the mlt system
mlt::factory_init( );

# Create the producer
$p = new mlt::MltProducer( $ARGV[0] );

if ( $p->is_valid != 0 )
{
	# Loop the video
	$p->set( "eof", "loop" );

	# Create the consumer
	$c = new mlt::MltConsumer( "sdl" );

	# Turn of the default rescaling
	$c->set( "rescale", "none" );
	
	# Connect the producer to the consumer
	$c->connect( $p );
	
	# Start the consumer
	$c->start;

	# Wait until the user stops the consumer
	while ( $c->is_stopped == 0 ) {
		sleep( 1 );
	}

	# Close the consumer
	$c->destroy;

	# Close the producer
	$p->destroy;
}
else
{
	print "Unable to open $ARGV[0]\n";
}

# Close the factory
mlt::factory_close( );
