#!/usr/bin/env python

# Import required modules
import mlt
import time
import sys

# Start the mlt system
mlt.factory_init( )

# Create the producer
p = mlt.factory_producer( "fezzik", sys.argv[1] )

if p:
	# Create the consumer
	c = mlt.factory_consumer( "sdl", "" )

	# Get the consumers properties
	r = mlt.mlt_consumer_properties( c )

	# Turn off the default rescaling
	mlt.mlt_properties_set( r, "rescale", "none" )
	
	# Get the producer service
	s = mlt.mlt_producer_service( p )
	
	# Connect the producer to the consumer
	mlt.mlt_consumer_connect( c, s )
	
	# Start the consumer
	mlt.mlt_consumer_start( c )
	
	# Wait until the user stops the consumer
	while mlt.mlt_consumer_is_stopped( c ) == 0:
		time.sleep( 1 )
	
	# Close the consumer
	mlt.mlt_consumer_close( c )

	# Close the producer
	mlt.mlt_producer_close( p )
else:
	# Diagnostics
	print "Unable to open ", sys.argv[ 1 ]

# Close the factory
mlt.factory_close( )
