#!/usr/bin/perl -w
# License OSI BSD
# pix_thumbs.pl:  Create an index page and thumbnails
# Copyright 5/3/2004 Robin.Rowe@MovieEditor.com 
# translated by heidi@animae.org 12/16/2005 from pix_thumbs.sh
# reorganized into functions 2/24/06 rsr

use strict;

my @subdirs = qw(day-1a  day-1b  day-1c  day-1d  day-2a  day-2b  day-2c  day-3a  day-3b  day-3c);
my $dir = "thumb";
#my $convert = q(gm convert -sample 5%x5%);
my $convert = q(gm convert -size 200x200);
my $resize = q(-resize 200x200 +profile "*");
my $wildcard = q(*.JPG);
my $cols = 5;
my $FH;
my $subdir;

sub MakeThumbDir
{	if(-d "$subdir/$dir")
	{	return;
	}
	mkdir("$subdir/$dir") or die("Could not make directory $subdir/$dir: $!");
}

sub PrintHeader
{	open($FH,">$subdir/$dir/index.html") or die("Could not open index.html: $!");
	print($FH <<ZZZ) or die($!);
<HTML><TITLE>$subdir</TITLE>
<BODY>$subdir<P> 
<TABLE BORDER="0" CELLSPACING="2" CELLPADDING="2">
ZZZ
}

sub ProcessImages
{	my $i = 0;
	foreach my $file (glob "$subdir/$wildcard")
	{	if(0==$i)
		{	  print($FH "<TR>") or die($!);
		}
		$file = substr($file,length($subdir)+1);
		print("$convert $subdir/$file\n");
		system("$convert $subdir/$file $resize $subdir/$dir/$file");
		print($FH <<ZZZ) or die($!);
<TD><IMG SRC=\"$file\" ALT=\"$file\"><BR>
$file</TD>
ZZZ
		$i++;
		if($cols==$i)
		{	$i=0;
			print($FH "</TR>\n") or die($!);
		}
	}
	if(0!=$i)
	{	$i=0;
		print($FH "</TR>") or die($!);
	}
	print($FH "</TABLE>") or die($!);	
}

sub PrintFooter
{	print($FH "</BODY></HTML>") or die($!);
	close($FH) or die($!);
}

sub CreateIndexAndThumbs
{	MakeThumbDir();
	PrintHeader();
	ProcessImages();
	PrintFooter();
}

sub main
{	foreach (@subdirs)
	{	$subdir = $_;
		print("$subdir\n");
		CreateIndexAndThumbs();
	}
	print("done!\n");
}

main();
