// unmangle
// Copyright 2005 Robin.Rowe@MovieEditor.com BSD license
// Unmangles VCPP7 function names to aid debugging dll link-time errors
// rsr 9/7/05

#include <iostream>
#include <string.h>
#include <Windows.h>
#include <Dbghelp.h>

using namespace std;

enum {buf_size=512};

void PrintInfo()
{	cout<<"*** unmangle ***"<<endl
		<<"Copyright 2005 Robin.Rowe@MovieEditor.com BSD license"<<endl
		<<"Unmangles VCPP7 function names to aid debugging dll link-time errors"<<endl;
}

void PrintUsage()
{	cout<<"\nEnter VCPP7 mangled function name (blankline to quit)"<<endl
	<<": ";
}

void PrintUnmangle(const char* mangled)
{	char unmangled[buf_size];
	DWORD status=UnDecorateSymbolName(mangled,unmangled,buf_size,UNDNAME_COMPLETE);
	if(!status)
	{	cout<<"UnDecorateSymbolName() Failed! GetLastError()="<<GetLastError()<<endl;
		return;
	}
	cout<<"  "<<unmangled<<endl;
}

int main(int argc,char* argv[])
{	PrintInfo();
	char buffer[buf_size];
	for(;;)
	{	PrintUsage();
		cin.getline(buffer,buf_size);
		if(char(0)==buffer[0])
		{	return 0;
		}
		PrintUnmangle(buffer);
	}
	return 0;
}
	
