// generated by Fast Light User Interface Designer (fluid) version 1.0104

#include "gradientui.h"
static Fl_Color_Button *activecolorbutton;
static Gradient *currgrad;

Fl_Named_RGB_Browser::Fl_Named_RGB_Browser(int x,int y,int w,int h,const char *l):Fl_Hold_Browser(x,y,w,h,l) {
  int ds=RgbDatabaseSize(),i;
RGBdb *rgbd;
char name[256];
if(ds>0) {
 for(i=0;i<ds;i++) { 
    rgbd=getRgbData(i);
    sprintf(name," %s\t(%d,%d,%d)",rgbd->name,
                 rgbd->r,rgbd->g,rgbd->b);
    add(name,rgbd);
 }
}
}

void Fl_Named_RGB_Browser::item_draw(void* v, int x, int y, int w, int h) const {
  struct FL_BLINE {	// data is in a linked list of these
  FL_BLINE* prev;
  FL_BLINE* next;
  void* data;
  short length;		// sizeof(txt)-1, may be longer than string
  char flags;		// selected, displayed
  char txt[1];		// start of allocated array
};
const int SELECTED=1;

char* str = ((FL_BLINE*)v)->txt;
RGBdb *rgbptr=(RGBdb*)(((FL_BLINE*)v)->data);
  const int* i = column_widths();

  fl_color(rgbptr->r,rgbptr->g,rgbptr->b);
  fl_rectf(x, y, 20, h);
  x+=20;
  w-=20;

  while (w > 6) {	// do each tab-seperated field
    int w1 = w;	// width for this field
    char* e = 0; // pointer to end of field or null if none
    if (*i) { // find end of field and temporarily replace with 0
      for (e = str; *e && *e != column_char(); e++);
      if (*e) {*e = 0; w1 = *i++;} else e = 0;
    }
    int size = textsize();
    Fl_Font font = textfont();
    Fl_Color lcol = textcolor(),olcol,obcolor;
    olcol=lcol;
    obcolor=fl_color();
    Fl_Align align = FL_ALIGN_LEFT;
    // check for all the @-lines recognized by XForms:
    while (*str == format_char() && *++str && *str != format_char()) {
      switch (*str++) {
      case 'l': case 'L': size = 24; break;
      case 'm': case 'M': size = 18; break;
      case 's': size = 11; break;
      case 'b': font = (Fl_Font)(font|FL_BOLD); break;
      case 'i': font = (Fl_Font)(font|FL_ITALIC); break;
      case 'f': case 't': font = FL_COURIER; break;
      case 'c': align = FL_ALIGN_CENTER; break;
      case 'r': align = FL_ALIGN_RIGHT; break;
      case 'B': 
	    if (!(((FL_BLINE*)v)->flags & SELECTED)) {
	      fl_color((Fl_Color)strtol(str, &str, 10));
	      fl_rectf(x, y, w1, h);
	    } else strtol(str, &str, 10);
        break;
      case 'C':
	lcol = (Fl_Color)strtol(str, &str, 10);
	break;
      case 'F':
	font = (Fl_Font)strtol(str, &str, 10);
	break;
      case 'N':
	lcol = FL_INACTIVE_COLOR;
	break;
      case 'S':
	size = strtol(str, &str, 10);
	break;
      case '-':
	fl_color(FL_DARK3);
	fl_line(x+3, y+h/2, x+w1-3, y+h/2);
	fl_color(FL_LIGHT3);
	fl_line(x+3, y+h/2+1, x+w1-3, y+h/2+1);
	break;
      case 'u':
      case '_':
	fl_color(lcol);
	fl_line(x+3, y+h-1, x+w1-3, y+h-1);
	break;
      case '.':
	goto BREAK;
      case '@':
	str--; goto BREAK;
      }
    }
  BREAK:
    fl_font(font, size);
    if (!active_r()) lcol = fl_inactive(lcol);
    if (((FL_BLINE*)v)->flags & SELECTED)
      lcol = fl_contrast(lcol, selection_color());
    fl_color(lcol);
    fl_draw(str, x+3, y, w1-6, h, e ? Fl_Align(align|FL_ALIGN_CLIP) : align);
    if (!e) break; // no more fields...
    *e = column_char(); // put the seperator back
    x += w1;
    w -= w1;
    str = e+1;
  }
}

void updateColorChooser(Gradient *cgrad,int curseg) {
  if(cgrad) {
 grad_segment_t *gs=cgrad->getseg(curseg);
 if(gs!=NULL) {
  lcolor->activate();
  rcolor->activate();
  linkedcolors->activate();
  if(editleft->value()) {
    rcolor->color(float(gs->r0),float(gs->g0),float(gs->b0),float(gs->a0));  
    if(gs->flags & GRAD_LEFT ) 
      linkedcolors->value(1);
    else 
      linkedcolors->value(0);
    if(curseg>0) {
      gs=cgrad->getseg(curseg-1);
      lcolor->color(float(gs->r1),float(gs->g1),float(gs->b1),float(gs->a1));
    } else {
      rcolor->color(float(gs->r0),float(gs->g0),float(gs->b0),float(gs->a0));  
      rcolor->value(1);
      rcolor->box(FL_THIN_DOWN_FRAME);
      activecolorbutton=rcolor;
      lcolor->value(0);
      lcolor->deactivate();
      lcolor->box(FL_THIN_UP_FRAME);
      linkedcolors->deactivate();
    }
  } else {
    lcolor->color(float(gs->r1),float(gs->g1),float(gs->b1),float(gs->a1));
    if(gs->flags & GRAD_RIGHT ) 
      linkedcolors->value(1);
    else 
      linkedcolors->value(0);
    if(curseg<cgrad->numsegs()-1) {
      gs=cgrad->getseg(curseg+1);
      rcolor->color(float(gs->r0),float(gs->g0),float(gs->b0),float(gs->a0));  
    } else {
      lcolor->color(float(gs->r1),float(gs->g1),float(gs->b1),float(gs->a1));
      lcolor->value(1);
      lcolor->box(FL_THIN_DOWN_FRAME);
      activecolorbutton=lcolor;
      rcolor->value(0);
      rcolor->deactivate();
      rcolor->box(FL_THIN_UP_FRAME);
      linkedcolors->deactivate();
    }
  }
//  lcolor->damage(FL_DAMAGE_EXPOSE);
//  rcolor->damage(FL_DAMAGE_EXPOSE);
//  linkedcolors->damage(FL_DAMAGE_EXPOSE);
    grcolorchoose->damage(FL_DAMAGE_EXPOSE);
    activecolorbutton->do_callback();
 }
}
}

void updateGrad(Gradient *cgrad,int curseg) {
  if(cgrad) {
 char flag=(cgrad->getseg(curseg))->flags;
 if(editleft->value()) {
   cgrad->setColor(curseg,GRAD_LEFT,
                  float(rcolor->red()),
                  float(rcolor->green()),
                  float(rcolor->blue()),
                  float(rcolor->alpha()),
   char((linkedcolors->value())?(GRAD_LEFT|flag):
                                ((~GRAD_LEFT)&flag))
);

  if(curseg>0) {
   flag=(cgrad->getseg(curseg-1))->flags;
   cgrad->setColor(curseg-1,GRAD_RIGHT,
                  float(lcolor->red()),
                  float(lcolor->green()),
                  float(lcolor->blue()),
                  float(lcolor->alpha()),
   char((linkedcolors->value())?(GRAD_RIGHT |flag):
                                ((~GRAD_RIGHT) &flag))
);
  }
 } else {
   cgrad->setColor(curseg,GRAD_RIGHT,
                  float(lcolor->red()),
                  float(lcolor->green()),
                  float(lcolor->blue()),
                  float(lcolor->alpha()),
  char((linkedcolors->value())?(GRAD_RIGHT | flag ):
                               ((~GRAD_RIGHT) & flag))
);
  if(curseg<cgrad->numsegs()-1){
   flag=cgrad->getseg(curseg+1)->flags;
   cgrad->setColor(curseg+1,GRAD_LEFT,
                  float(rcolor->red()),
                  float(rcolor->green()),
                  float(rcolor->blue()),
                  float(rcolor->alpha()),
  char((linkedcolors->value())?(GRAD_LEFT | flag):
                               ((~GRAD_LEFT) & flag))
);
  }
 }
 gradbox->damage(FL_DAMAGE_EXPOSE);
}
}

Fl_Double_Window *yagemainwin=(Fl_Double_Window *)0;

static void cb_New(Fl_Menu_*, void*) {
  char tmpb[512];
currgrad->setdefaults();
strcpy(tmpb,"YAGE (yet another gradient editor) ");
yagemainwin->label(tmpb);
int ns;
double *sl=currgrad->getsegments(ns);
colorval->setsegments(ns,sl);
colormval->setsegments(ns,sl);
gradname->value(currgrad->gradname);
ftype->value(currgrad->grad_type-1);
ftype->do_callback();
ftype->damage(FL_DAMAGE_EXPOSE);
gradientgroup->damage(FL_DAMAGE_EXPOSE);
yagemainwin->damage(FL_DAMAGE_EXPOSE);
}

static void cb_Open(Fl_Menu_*, void*) {
  char *fname=fl_file_chooser("Gradient File","*",NULL);
if(fname!=NULL) {
 char tmpb[512];
 if(currgrad->load(fname,GRAD_AUTO)) {
   strcpy(tmpb,"YAGE - ");
   strcat(tmpb,fname);
   yagemainwin->label(tmpb);
   int ns;
   double *sl=currgrad->getsegments(ns);
   colorval->setsegments(ns,sl);
   colormval->setsegments(ns,sl);
   gradname->value(currgrad->gradname);
   ftype->value(currgrad->grad_type-1);
   ftype->do_callback();
   ftype->damage(FL_DAMAGE_EXPOSE);
   gradientgroup->damage(FL_DAMAGE_EXPOSE);
   yagemainwin->damage(FL_DAMAGE_EXPOSE);
  }
};
}

static void cb_Save(Fl_Menu_*, void*) {
  char *fname=fl_file_chooser("Gradient File","*",currgrad->gradfilename);
if(fname!=NULL) {
 char tmpb[512];
 if(currgrad->save(fname,ftype->value()+1)) {
   strcpy(tmpb,"YAGE - ");
   strcat(tmpb,fname);
   yagemainwin->label(tmpb);
   int ns;
   double *sl=currgrad->getsegments(ns);
   colorval->setsegments(ns,sl);
   colormval->setsegments(ns,sl);
   gradname->value(currgrad->gradname);
   gradientgroup->damage(FL_DAMAGE_EXPOSE);
   yagemainwin->damage(FL_DAMAGE_EXPOSE);
  }
};
}

static void cb_Exit(Fl_Menu_*, void*) {
  exit(0);
}

static void cb_About(Fl_Menu_*, void*) {
  about_window->show();
}

static void cb_Manual(Fl_Menu_*, void*) {
  manual_window->show();
}

Fl_Menu_Item menu_[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 12, 56},
 {"&New", 0x40067,  (Fl_Callback*)cb_New, 0, 128, 0, 0, 12, 56},
 {"&Open...", 0x4006f,  (Fl_Callback*)cb_Open, 0, 0, 0, 0, 12, 56},
 {"&Save..", 0x40073,  (Fl_Callback*)cb_Save, 0, 128, 0, 0, 12, 56},
 {"&Exit", 0xff1b,  (Fl_Callback*)cb_Exit, 0, 0, 0, 0, 12, 56},
 {0},
 {"&Help", 0,  0, 0, 64, 0, 0, 12, 56},
 {"&About YAGE", 0,  (Fl_Callback*)cb_About, 0, 0, 0, 0, 12, 56},
 {"&Manual", 0,  (Fl_Callback*)cb_Manual, 0, 0, 0, 0, 12, 56},
 {0},
 {0}
};

Fl_Group *gradientgroup=(Fl_Group *)0;

Fl_Multi_Value_Slider *colorval=(Fl_Multi_Value_Slider *)0;

static void cb_colorval(Fl_Multi_Value_Slider* o, void*) {
  double *slist;
int nsegs,ocsegs,onsegs,nvsegs;
slist=o->getsegments(nsegs);
ocsegs=colormval->current_segment();
onsegs=colormval->numsegs();
if(gradbox->grad()){
  if(onsegs<nsegs) {
    gradbox->grad()->split_segment(ocsegs);
  } else if(onsegs>nsegs) {
    gradbox->grad()->remove_segment(ocsegs);
  } else {
    gradbox->grad()->updatesegments(nsegs,slist);
  }
  gradbox->damage(FL_DAMAGE_EXPOSE);
}
nvsegs=o->current_segment();
colormval->setsegments(nsegs,slist);
colormval->value(o->value());
colormval->current_segment(nvsegs);
if(nvsegs!=ocsegs || onsegs!=nsegs)
  updateColorChooser(currgrad,nvsegs);
o->damage(FL_DAMAGE_EXPOSE);
colorval->damage(FL_DAMAGE_EXPOSE);
if(slist!=NULL) free(slist);
}

Fl_Multi_Value_Slider *colormval=(Fl_Multi_Value_Slider *)0;

static void cb_colormval(Fl_Multi_Value_Slider* o, void*) {
  double *slist;
int nsegs,ocsegs,onsegs,nvsegs;
slist=o->getsegments(nsegs);
ocsegs=colorval->current_segment();
onsegs=colorval->numsegs();
if(gradbox->grad()){
  if(onsegs<nsegs) {
    gradbox->grad()->split_segment(ocsegs);
  } else if(onsegs>nsegs) {
    gradbox->grad()->remove_segment(ocsegs);
  } else {
    gradbox->grad()->updatesegments(nsegs,slist);
  }
  gradbox->damage(FL_DAMAGE_EXPOSE);
}
nvsegs=o->current_segment();
colorval->setsegments(nsegs,slist);
colorval->value(o->value());
colorval->current_segment(nvsegs);
if(nvsegs!=ocsegs || onsegs!=nsegs)
  updateColorChooser(currgrad,nvsegs);
o->damage(FL_DAMAGE_EXPOSE);
colorval->damage(FL_DAMAGE_EXPOSE);
if(slist!=NULL) free(slist);
}

Fl_Gradient_Box *gradbox=(Fl_Gradient_Box *)0;

static void cb_gradbox(Fl_Gradient_Box*, void*) {
  Fl::focus(colorval);
colorval->damage(FL_DAMAGE_EXPOSE);
}

Fl_Input *gradname=(Fl_Input *)0;

Fl_Choice *ftype=(Fl_Choice *)0;

static void cb_ftype(Fl_Choice* o, void*) {
  if(o->value()==0) {
 colormval->samesize(0);
 colorval->samesize(0);
} else if(o->value()==1) {
  colormval->samesize(1);
  colorval->samesize(1);
}
colorval->do_callback();
gradientgroup->damage(FL_DAMAGE_EXPOSE);
}

Fl_Menu_Item menu_ftype[] = {
 {"GIMP", 0,  0, 0, 4, 0, 0, 10, 56},
 {"VU", 0,  0, 0, 4, 0, 0, 10, 56},
 {0}
};

static void cb_(Fl_Button*, void*) {
  char tmpb[512];
currgrad->setdefaults();
strcpy(tmpb,"YAGE (yet another gradient editor) ");
yagemainwin->label(tmpb);
int ns;
double *sl=currgrad->getsegments(ns);
colorval->setsegments(ns,sl);
colormval->setsegments(ns,sl);
gradname->value(currgrad->gradname);
ftype->value(currgrad->grad_type-1);
ftype->do_callback();
ftype->damage(FL_DAMAGE_EXPOSE);
gradientgroup->damage(FL_DAMAGE_EXPOSE);
yagemainwin->damage(FL_DAMAGE_EXPOSE);
}

#include <FL/Fl_Pixmap.H>
static const char *idata_img_gradient_new[] = {
"16 16 3 1",
" \tc #C1C1C1C1C1C1",
".\tc #000000000000",
"X\tc #FFFFFFFFFFFF",
"                ",
"  ........      ",
"  .XXXXX.X.     ",
"  .XXXXX.XX.    ",
"  .XXXXX.XXX.   ",
"  .XXXXX.....   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  .XXXXXXXXX.   ",
"  ...........   ",
"                "
};
static Fl_Pixmap image_img_gradient_new(idata_img_gradient_new);

static void cb_1(Fl_Button*, void*) {
  char *fname=fl_file_chooser("Gradient File","*",NULL);
if(fname!=NULL) {
 char tmpb[512];
 if(currgrad->load(fname,GRAD_AUTO)) {
   strcpy(tmpb,"YAGE - ");
   strcat(tmpb,fname);
   yagemainwin->label(tmpb);
   int ns;
   double *sl=currgrad->getsegments(ns);
   colorval->setsegments(ns,sl);
   colormval->setsegments(ns,sl);
   gradname->value(currgrad->gradname);
   ftype->value(currgrad->grad_type-1);
   ftype->do_callback();
   ftype->damage(FL_DAMAGE_EXPOSE);
   gradientgroup->damage(FL_DAMAGE_EXPOSE);
   yagemainwin->damage(FL_DAMAGE_EXPOSE);
  }
};
}

static const char *idata_img_gradient_open[] = {
"16 16 6 1",
" \tc None",
".\tc #C1C1C1",
"+\tc #000000",
"@\tc #FFFFFF",
"#\tc #608FFF",
"$\tc #BFD3FF",
"...+++++++++++++",
"...+@@@@@@@@@@@+",
"...+@@########@+",
"...+@@@@@@@@@@@+",
"...+@########@@+",
"..++++@@@@@@@@@+",
".+$$$$+@######@+",
".+$###++++++@@@+",
".+$#########+@@+",
"++++++++####+#@+",
"+$$$$$$$+###+@@+",
"+$$######+##+@@+",
"+$$######+##+#@+",
".+$#######+#+@@+",
".+$#######+#++++",
"..++++++++++...."
};
static Fl_Pixmap image_img_gradient_open(idata_img_gradient_open);

static void cb_2(Fl_Button*, void*) {
  char *fname=fl_file_chooser("Gradient File","*",currgrad->gradfilename);
if(fname!=NULL) {
 char tmpb[512];
 if(currgrad->save(fname,ftype->value()+1)) {
   strcpy(tmpb,"YAGE - ");
   strcat(tmpb,fname);
   yagemainwin->label(tmpb);
   int ns;
   double *sl=currgrad->getsegments(ns);
   colorval->setsegments(ns,sl);
   colormval->setsegments(ns,sl);
   gradname->value(currgrad->gradname);
   gradientgroup->damage(FL_DAMAGE_EXPOSE);
   yagemainwin->damage(FL_DAMAGE_EXPOSE);
  }
};
}

static const char *idata_img_gradient_save[] = {
"16 16 12 1",
" \tc None",
".\tc #C1C1C1",
"+\tc #000000",
"@\tc #608FFF",
"#\tc #4644FF",
"$\tc #F6FFED",
"%\tc #0E00FF",
"&\tc #E3FFC7",
"*\tc #1104FF",
"=\tc #FFF9AF",
"-\tc #05009B",
";\tc #FFDB00",
".++++++++++++...",
"+@@#@@$$$$$@@+..",
"+@#%##&&&#&@##+.",
"+@#%##&&&#&@##*+",
"+@#%##&&&&&@##%+",
"+@##@@@@@@@###%+",
"+@############%+",
"+@############%+",
"+@############%+",
"+@##========##%+",
"+@##=######=##%+",
"+@##========#-%+",
"+@##=######=#-%+",
"+@##========##%+",
"+%%%;;;;;;;;%%%+",
".++++++++++++++."
};
static Fl_Pixmap image_img_gradient_save(idata_img_gradient_save);

static void cb_3(Fl_Button*, void*) {
  exit(0);
}

static const char *idata_img_gradient_exit[] = {
"16 16 6 1",
" \tc None",
".\tc #C1C1C1",
"+\tc #FF0000",
"@\tc #000000",
"#\tc #FFC406",
"$\tc #FFFFFF",
"................",
"......+++++.....",
"...@@@+++++@@@..",
"...@#######@$@..",
"...@#######@$@..",
"...@#######@$@..",
"...@#####@@@$@..",
"...@#####@@@$@..",
"...@#######@$@..",
"...@#######@$@..",
"...@#######@$@..",
"...@#######@$@..",
"...@######@@$@..",
"...@###@@@$$$@..",
"...@#@@$$$$$$@..",
"...@@$$$$$$$$@.."
};
static Fl_Pixmap image_img_gradient_exit(idata_img_gradient_exit);

Fl_Light_Button *editleft=(Fl_Light_Button *)0;

static void cb_editleft(Fl_Light_Button* o, void*) {
  editright->value(!o->value());
updateColorChooser(currgrad,colorval->current_segment());
Fl::focus(activecolorbutton);
}

Fl_Light_Button *editright=(Fl_Light_Button *)0;

static void cb_editright(Fl_Light_Button* o, void*) {
  editleft->value(!o->value());
updateColorChooser(currgrad,colorval->current_segment());
Fl::focus(activecolorbutton);
}

static void cb_11(Fl_Button*, void*) {
  int ocsegs=colormval->current_segment();
grad_segment_t *gs=currgrad->getseg(ocsegs);
gs->r0=gs->r1;
gs->g0=gs->g1;
gs->b0=gs->b1;
gs->a0=gs->a1;
if(ocsegs<currgrad->numsegs()-1 && (gs->flags & GRAD_RIGHT)) {
 grad_segment_t *gs1=currgrad->getseg(ocsegs+1);
 gs1->r0=gs->r1;
 gs1->g0=gs->g1;
 gs1->b0=gs->b1;
 gs1->a0=gs->a1;
}

updateColorChooser(currgrad,ocsegs);
}

static void cb_12(Fl_Button*, void*) {
  int ocsegs=colormval->current_segment();
grad_segment_t *gs=currgrad->getseg(ocsegs);
gs->r0=gs->r1;
gs->g0=gs->g1;
gs->b0=gs->b1;
gs->a0=gs->a1;
if(ocsegs>0 && (gs->flags & GRAD_LEFT)) {
 grad_segment_t *gs1=currgrad->getseg(ocsegs-1);
 gs1->r1=gs->r0;
 gs1->g1=gs->g0;
 gs1->b1=gs->b0;
 gs1->a1=gs->a0;
}
updateColorChooser(currgrad,ocsegs);
}

Fl_Group *grcolorchoose=(Fl_Group *)0;

Fl_Color_Button *lcolor=(Fl_Color_Button *)0;

static void cb_lcolor(Fl_Color_Button* o, void*) {
  activecolorbutton=o;
o->box(FL_THIN_DOWN_FRAME);
rcolor->box(FL_THIN_UP_FRAME);
o->damage(FL_DAMAGE_EXPOSE);
rcolor->damage(FL_DAMAGE_EXPOSE);
if(colorschemetabs->value()==colchooserrgba ) {
   colchooserrgba->rgb((double)o->red(),(double)o->green(),(double)o->blue(),(double)o->alpha());
   colchooserrgba->damage(FL_DAMAGE_EXPOSE);
} else if (colorschemetabs->value()== palettetab) {
   colchoosepalette->color((unsigned char)(o->red()*255),
         (unsigned char)(o->green()*255),
         (unsigned char)(o->blue()*255));
   if(o->alpha()<1)
     palettedalpha->value(1);

   colchooserrgba->damage(FL_DAMAGE_EXPOSE);
} else if (colorschemetabs->value()== namedcolortab) {
   namedred->value(o->red()*255);
   namedgreen->value(o->green()*255);
   namedblue->value(o->blue()*255);
   if(o->alpha()<1)
     namedalpha->value(1);
   namedblue->do_callback();
   namedcolortab->damage(FL_DAMAGE_EXPOSE);
}


if(linkedcolors->value())  
   linkedcolors->do_callback();

int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Color_Button *rcolor=(Fl_Color_Button *)0;

static void cb_rcolor(Fl_Color_Button* o, void*) {
  activecolorbutton=o;
o->box(FL_THIN_DOWN_FRAME);
lcolor->box(FL_THIN_UP_FRAME);
o->damage(FL_DAMAGE_EXPOSE);
lcolor->damage(FL_DAMAGE_EXPOSE);
if(colorschemetabs->value()==colchooserrgba ) {
   colchooserrgba->rgb((double)o->red(),(double)o->green(),(double)o->blue(),(double)o->alpha());
   colchooserrgba->damage(FL_DAMAGE_EXPOSE);
} else if (colorschemetabs->value()== palettetab) {
   colchoosepalette->color((unsigned char)(o->red()*255),
         (unsigned char)(o->green()*255),
         (unsigned char)(o->blue()*255));
   if(o->alpha()<1)
     palettedalpha->value(1);
   colchooserrgba->damage(FL_DAMAGE_EXPOSE);
} else if (colorschemetabs->value()== namedcolortab) {
   namedred->value(o->red()*255);
   namedgreen->value(o->green()*255);
   namedblue->value(o->blue()*255);
   if(o->alpha()<1)
     namedalpha->value(1);
   namedblue->do_callback();
   namedcolortab->damage(FL_DAMAGE_EXPOSE);
}

if(linkedcolors->value())  
   linkedcolors->do_callback();

int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Button *colLtoR=(Fl_Button *)0;

static void cb_colLtoR(Fl_Button* o, void*) {
  rcolor->color(lcolor->red(),lcolor->green(),
              lcolor->blue(),lcolor->alpha());
o->damage(FL_DAMAGE_EXPOSE);
rcolor->damage(FL_DAMAGE_EXPOSE);

int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Button *colRtoL=(Fl_Button *)0;

static void cb_colRtoL(Fl_Button* o, void*) {
  lcolor->color(rcolor->red(),rcolor->green(),
              rcolor->blue(),rcolor->alpha());
o->damage(FL_DAMAGE_EXPOSE);
rcolor->damage(FL_DAMAGE_EXPOSE);

int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Check_Button *linkedcolors=(Fl_Check_Button *)0;

static void cb_linkedcolors(Fl_Check_Button* o, void*) {
  int ocsegs=colorval->current_segment();

if(o->value()) {
 if(activecolorbutton==lcolor) {
   colLtoR->do_callback();
 } else {
   colRtoL->do_callback();
 }
} else {
}

ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Tabs *colorschemetabs=(Fl_Tabs *)0;

static void cb_colorschemetabs(Fl_Tabs*, void*) {
  activecolorbutton->do_callback();
}

Fl_Color_Chooser_A *colchooserrgba=(Fl_Color_Chooser_A *)0;

static void cb_colchooserrgba(Fl_Color_Chooser_A* o, void*) {
  activecolorbutton->color((float)o->r(),
  (float)o->g(),
  (float)o->b(),
  (float)o->a());
activecolorbutton->damage(FL_DAMAGE_EXPOSE);
if(linkedcolors->value())  
   linkedcolors->do_callback();

int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Group *palettetab=(Fl_Group *)0;

Fl_Color_Menu *colchoosepalette=(Fl_Color_Menu *)0;

static void cb_colchoosepalette(Fl_Color_Menu* o, void*) {
  unsigned char r,g,b;
Fl::get_color(o->color(),r,g,b);
activecolorbutton->color(r,g,b,
  (unsigned char)((palettedalpha->value())?
         (activecolorbutton->alpha()*255)
         :255)
);
activecolorbutton->damage(FL_DAMAGE_ALL);

if(linkedcolors->value())  
   linkedcolors->do_callback();

int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
}

Fl_Check_Button *palettedalpha=(Fl_Check_Button *)0;

static void cb_palettedalpha(Fl_Check_Button*, void*) {
  colchoosepalette->do_callback();
}

Fl_Group *namedcolortab=(Fl_Group *)0;

Fl_Named_RGB_Browser *browsergb=(Fl_Named_RGB_Browser *)0;

static void cb_browsergb(Fl_Named_RGB_Browser* o, void*) {
  RGBdb *rgbptr=(RGBdb*)(o->data(((Fl_Browser*)o)->value()));

if(rgbptr!=NULL) {
 namedred->value(rgbptr->r);
 namedgreen->value(rgbptr->g);
 namedblue->value(rgbptr->b);

activecolorbutton->color( 
 (unsigned char)(namedred->value()),
  (unsigned char)(namedgreen->value()),
  (unsigned char)(namedblue->value()),
  (unsigned char)((namedalpha->value())?
         (activecolorbutton->alpha()*255)
         :255)
);
activecolorbutton->damage(FL_DAMAGE_EXPOSE);

if(linkedcolors->value())  
   linkedcolors->do_callback();
int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
};
}

Fl_Value_Input_Spin *namedred=(Fl_Value_Input_Spin *)0;

static void cb_namedred(Fl_Value_Input_Spin*, void*) {
  int i;
browsergb->select(
  i=(getRgbEntry(int(namedred->value()),
    int(namedgreen->value()),
    int(namedblue->value()))+1));
browsergb->value(i);
browsergb->damage(FL_DAMAGE_EXPOSE);

RGBdb *rgbptr=(RGBdb*)(browsergb->data(i));

if(rgbptr!=NULL) {

activecolorbutton->color( 
 (unsigned char)(rgbptr->r),
  (unsigned char)(rgbptr->g),
  (unsigned char)(rgbptr->b),
  (unsigned char)((namedalpha->value())?
         (activecolorbutton->alpha()*255)
         :255)
);
activecolorbutton->damage(FL_DAMAGE_EXPOSE);

if(linkedcolors->value())  
   linkedcolors->do_callback();
int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
};
}

Fl_Value_Input_Spin *namedgreen=(Fl_Value_Input_Spin *)0;

static void cb_namedgreen(Fl_Value_Input_Spin*, void*) {
  int i;
browsergb->select(
  i=(getRgbEntry(int(namedred->value()),
    int(namedgreen->value()),
    int(namedblue->value()))+1));
browsergb->value(i);
browsergb->damage(FL_DAMAGE_EXPOSE);

RGBdb *rgbptr=(RGBdb*)(browsergb->data(i));

if(rgbptr!=NULL) {

activecolorbutton->color( 
 (unsigned char)(rgbptr->r),
  (unsigned char)(rgbptr->g),
  (unsigned char)(rgbptr->b),
  (unsigned char)((namedalpha->value())?
         (activecolorbutton->alpha()*255)
         :255)
);
activecolorbutton->damage(FL_DAMAGE_EXPOSE);

if(linkedcolors->value())  
   linkedcolors->do_callback();
int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
};
}

Fl_Value_Input_Spin *namedblue=(Fl_Value_Input_Spin *)0;

static void cb_namedblue(Fl_Value_Input_Spin*, void*) {
  int i;
browsergb->select(
  i=(getRgbEntry(int(namedred->value()),
    int(namedgreen->value()),
    int(namedblue->value()))+1));
browsergb->value(i);
browsergb->damage(FL_DAMAGE_EXPOSE);

RGBdb *rgbptr=(RGBdb*)(browsergb->data(i));

if(rgbptr!=NULL) {

activecolorbutton->color( 
 (unsigned char)(rgbptr->r),
  (unsigned char)(rgbptr->g),
  (unsigned char)(rgbptr->b),
  (unsigned char)((namedalpha->value())?
         (activecolorbutton->alpha()*255)
         :255)
);
activecolorbutton->damage(FL_DAMAGE_EXPOSE);

if(linkedcolors->value())  
   linkedcolors->do_callback();
int ocsegs=colormval->current_segment();
updateGrad(currgrad,ocsegs);
};
}

Fl_Check_Button *namedalpha=(Fl_Check_Button *)0;

static void cb_namedalpha(Fl_Check_Button*, void*) {
  browsergb->do_callback();
}

Fl_Double_Window *about_window=(Fl_Double_Window *)0;

static void cb_about_window(Fl_Double_Window* o, void*) {
  o->hide();
}

static void cb_OK(Fl_Return_Button* o, void*) {
  ((Fl_Window*)(o->parent()))->hide();
}

Fl_Double_Window *manual_window=(Fl_Double_Window *)0;

static void cb_manual_window(Fl_Double_Window* o, void*) {
  o->hide();
}

static void cb_OK1(Fl_Return_Button* o, void*) {
  ((Fl_Window*)(o->parent()))->hide();
}

Fl_Double_Window* make_window(Gradient *cgrad) {
  Fl_Double_Window* w;
  currgrad=cgrad;
  { Fl_Double_Window* o = yagemainwin = new Fl_Double_Window(447, 349, "YAGE (yet another gradient editor)");
    w = o;
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 447, 23);
      o->box(FL_THIN_UP_BOX);
      o->menu(menu_);
    }
    { Fl_Group* o = new Fl_Group(4, 24, 440, 130);
      o->box(FL_ENGRAVED_FRAME);
      o->labelsize(12);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
      { Fl_Group* o = gradientgroup = new Fl_Group(12, 50, 428, 98);
        { Fl_Multi_Value_Slider* o = colorval = new Fl_Multi_Value_Slider(12, 136, 428, 12);
          o->tooltip("Ins: add segment  Del: remove segment");
          o->type(1);
          o->box(FL_FLAT_BOX);
          o->color(FL_DARK2);
          o->selection_color(FL_FOREGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_BLACK);
          o->textcolor(54);
          o->callback((Fl_Callback*)cb_colorval);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_CHANGED);
          o->usevals(FL_MVS_LIMITS_ON);
          int ns;double *sl=currgrad->getsegments(ns);
          o->setsegments(ns,sl);
        }
        { Fl_Multi_Value_Slider* o = colormval = new Fl_Multi_Value_Slider(12, 51, 428, 12);
          o->tooltip("Ins: add segment  Del: remove segment");
          o->type(1);
          o->box(FL_FLAT_BOX);
          o->color(FL_DARK2);
          o->selection_color(FL_FOREGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_BLACK);
          o->slider_size(1);
          o->textcolor(54);
          o->callback((Fl_Callback*)cb_colormval);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_CHANGED);
          o->usevals(FL_MVS_MVALS_ON);
          int ns;double *sl=currgrad->getsegments(ns);
          o->setsegments(ns,sl);
        }
        { Fl_Gradient_Box* o = gradbox = new Fl_Gradient_Box(12, 63, 428, 73, "Gradient Image");
          o->box(FL_BORDER_BOX);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color((Fl_Color)1);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_BLACK);
          o->callback((Fl_Callback*)cb_gradbox);
          o->align(FL_ALIGN_CENTER);
          o->when(FL_WHEN_RELEASE);
          Fl_Group::current()->resizable(o);
          o->grad(currgrad);
        }
        o->end();
        Fl_Group::current()->resizable(o);
      }
      { Fl_Group* o = new Fl_Group(11, 28, 411, 21);
        { Fl_Input* o = gradname = new Fl_Input(139, 30, 172, 18, "Name:");
          o->box(FL_THIN_DOWN_BOX);
          o->labelsize(10);
          o->textsize(10);
          o->value(currgrad->gradname);
        }
        { Fl_Choice* o = ftype = new Fl_Choice(342, 30, 63, 18, "type:");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(10);
          o->textsize(10);
          o->callback((Fl_Callback*)cb_ftype);
          o->when(FL_WHEN_CHANGED);
          o->menu(menu_ftype);
          o->value(currgrad->grad_type-1);
        }
        { Fl_Box* o = new Fl_Box(410, 30, 12, 19);
          Fl_Group::current()->resizable(o);
        }
        { Fl_Button* o = new Fl_Button(11, 28, 22, 20);
          o->tooltip("New Gradient (Ctrl+g)");
          o->box(FL_THIN_UP_BOX);
          o->image(image_img_gradient_new);
          o->callback((Fl_Callback*)cb_);
        }
        { Fl_Button* o = new Fl_Button(35, 28, 22, 20);
          o->tooltip("Open Gradient (Ctrl+o)");
          o->box(FL_THIN_UP_BOX);
          o->image(image_img_gradient_open);
          o->callback((Fl_Callback*)cb_1);
        }
        { Fl_Button* o = new Fl_Button(59, 28, 22, 20);
          o->tooltip("Save Gradient (Ctrl+s)");
          o->box(FL_THIN_UP_BOX);
          o->image(image_img_gradient_save);
          o->callback((Fl_Callback*)cb_2);
        }
        { Fl_Button* o = new Fl_Button(84, 28, 22, 20);
          o->tooltip("Exit program (Esc)");
          o->box(FL_THIN_UP_BOX);
          o->image(image_img_gradient_exit);
          o->callback((Fl_Callback*)cb_3);
        }
        o->end();
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(3, 156, 441, 186);
      o->box(FL_ENGRAVED_FRAME);
      o->labelsize(12);
      o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
      { Fl_Group* o = new Fl_Group(13, 163, 168, 176);
        { Fl_Group* o = new Fl_Group(13, 163, 168, 100, "Edit segment extreme:");
          o->box(FL_ENGRAVED_BOX);
          o->labelsize(12);
          o->align(133|FL_ALIGN_INSIDE);
          { Fl_Light_Button* o = editleft = new Fl_Light_Button(20, 183, 54, 27, "Left");
            o->box(FL_THIN_UP_BOX);
            o->value(1);
            o->labelsize(12);
            o->callback((Fl_Callback*)cb_editleft);
          }
          { Fl_Light_Button* o = editright = new Fl_Light_Button(121, 182, 53, 28, "Right");
            o->box(FL_THIN_UP_BOX);
            o->labelsize(12);
            o->callback((Fl_Callback*)cb_editright);
          }
          { Fl_Button* o = new Fl_Button(87, 182, 29, 14, "@-1->");
            o->box(FL_THIN_UP_BOX);
            o->labeltype(FL_SHADOW_LABEL);
            o->labelcolor((Fl_Color)16);
            o->callback((Fl_Callback*)cb_11);
          }
          { Fl_Button* o = new Fl_Button(81, 197, 25, 14, "@-1<-");
            o->box(FL_THIN_UP_BOX);
            o->labeltype(FL_SHADOW_LABEL);
            o->labelcolor((Fl_Color)16);
            o->callback((Fl_Callback*)cb_12);
          }
          o->end();
        }
        { Fl_Group* o = new Fl_Group(25, 216, 143, 116);
          o->box(FL_ENGRAVED_BOX);
          { Fl_Group* o = new Fl_Group(35, 222, 119, 20);
            { Fl_Box* o = new Fl_Box(35, 222, 45, 20, "left segment");
              o->box(FL_FLAT_BOX);
              o->color((Fl_Color)53);
              o->labelsize(8);
              o->align(133|FL_ALIGN_INSIDE);
            }
            { Fl_Box* o = new Fl_Box(104, 222, 50, 20, "right segment");
              o->box(FL_FLAT_BOX);
              o->color((Fl_Color)53);
              o->labelsize(8);
              o->align(137|FL_ALIGN_INSIDE);
            }
            { Fl_Box* o = new Fl_Box(76, 222, 39, 20, "@2>");
              o->box(FL_FLAT_BOX);
              o->color((Fl_Color)53);
              o->labelsize(16);
              o->labelcolor(FL_DARK1);
              o->align(129|FL_ALIGN_INSIDE);
            }
            o->end();
          }
          { Fl_Group* o = grcolorchoose = new Fl_Group(36, 242, 117, 87);
            { Fl_Color_Button* o = lcolor = new Fl_Color_Button(36, 243, 42, 47);
              o->box(FL_UP_BOX);
              o->value(1);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(12);
              o->labelcolor(FL_BLACK);
              o->callback((Fl_Callback*)cb_lcolor);
              o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
              o->when(FL_WHEN_RELEASE);
            }
            { Fl_Color_Button* o = rcolor = new Fl_Color_Button(112, 243, 41, 47);
              o->box(FL_DOWN_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(12);
              o->labelcolor(FL_BLACK);
              o->callback((Fl_Callback*)cb_rcolor);
              o->align(FL_ALIGN_TOP);
              o->when(FL_WHEN_RELEASE);
            }
            { Fl_Button* o = colLtoR = new Fl_Button(86, 248, 25, 17, "@->");
              o->box(FL_THIN_UP_BOX);
              o->labeltype(FL_SHADOW_LABEL);
              o->labelcolor((Fl_Color)16);
              o->callback((Fl_Callback*)cb_colLtoR);
            }
            { Fl_Button* o = colRtoL = new Fl_Button(80, 268, 25, 17, "@<-");
              o->box(FL_THIN_UP_BOX);
              o->labeltype(FL_SHADOW_LABEL);
              o->labelcolor((Fl_Color)16);
              o->callback((Fl_Callback*)cb_colRtoL);
            }
            { Fl_Check_Button* o = linkedcolors = new Fl_Check_Button(88, 295, 19, 17, "Link");
              o->box(FL_FLAT_BOX);
              o->down_box(FL_DOWN_BOX);
              o->callback((Fl_Callback*)cb_linkedcolors);
              o->align(FL_ALIGN_BOTTOM);
            }
            new Fl_Box(60, 298, 24, 15, "@line");
            new Fl_Box(57, 290, 15, 14, "@2line");
            new Fl_Box(105, 298, 28, 15, "@line");
            new Fl_Box(119, 290, 15, 14, "@2line");
            o->end();
          }
          o->end();
        }
        { Fl_Box* o = new Fl_Box(79, 333, 26, 6);
          Fl_Group::current()->resizable(o);
        }
        o->end();
      }
      { Fl_Tabs* o = colorschemetabs = new Fl_Tabs(195, 164, 243, 172);
        o->callback((Fl_Callback*)cb_colorschemetabs);
        { Fl_Color_Chooser_A* o = colchooserrgba = new Fl_Color_Chooser_A(199, 188, 234, 145, "TrueColor");
          o->box(FL_NO_BOX);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(10);
          o->labelcolor(FL_BLACK);
          o->callback((Fl_Callback*)cb_colchooserrgba);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_CHANGED);
          o->textsize(10);
          o->end();
        }
        { Fl_Group* o = palettetab = new Fl_Group(196, 183, 240, 151, "Palette");
          o->labelsize(10);
          o->hide();
          { Fl_Color_Menu* o = colchoosepalette = new Fl_Color_Menu(196, 208, 240, 126);
            o->box(FL_FLAT_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_BLACK);
            o->callback((Fl_Callback*)cb_colchoosepalette);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->end();
            Fl_Group::current()->resizable(o);
          }
          { Fl_Check_Button* o = palettedalpha = new Fl_Check_Button(203, 190, 69, 17, "keep alpha");
            o->down_box(FL_DOWN_BOX);
            o->labelsize(10);
            o->callback((Fl_Callback*)cb_palettedalpha);
          }
          o->end();
        }
        { Fl_Group* o = namedcolortab = new Fl_Group(197, 186, 239, 148, "Named");
          o->box(FL_FLAT_BOX);
          o->labelsize(10);
          o->hide();
          { Fl_Named_RGB_Browser* o = browsergb = new Fl_Named_RGB_Browser(199, 213, 235, 121);
            o->type(2);
            o->box(FL_NO_BOX);
            o->color(FL_BACKGROUND2_COLOR);
            o->selection_color(FL_SELECTION_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(9);
            o->labelcolor(FL_BLACK);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_browsergb);
            o->align(FL_ALIGN_BOTTOM);
            o->when(FL_WHEN_CHANGED);
            Fl_Group::current()->resizable(o);
          }
          { Fl_Value_Input_Spin* o = namedred = new Fl_Value_Input_Spin(210, 191, 38, 18, "r:");
            o->box(FL_THIN_DOWN_BOX);
            o->color((Fl_Color)122);
            o->selection_color(FL_SELECTION_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(255);
            o->step(1);
            o->textsize(10);
            o->textcolor(7);
            o->callback((Fl_Callback*)cb_namedred);
            o->align(FL_ALIGN_LEFT);
            o->when(FL_WHEN_CHANGED);
          }
          { Fl_Value_Input_Spin* o = namedgreen = new Fl_Value_Input_Spin(263, 191, 38, 18, "g:");
            o->box(FL_THIN_DOWN_BOX);
            o->color((Fl_Color)10);
            o->selection_color(FL_SELECTION_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(255);
            o->step(1);
            o->textsize(10);
            o->textcolor(7);
            o->callback((Fl_Callback*)cb_namedgreen);
            o->align(FL_ALIGN_LEFT);
            o->when(FL_WHEN_CHANGED);
          }
          { Fl_Value_Input_Spin* o = namedblue = new Fl_Value_Input_Spin(316, 191, 36, 18, "b:");
            o->box(FL_THIN_DOWN_BOX);
            o->color((Fl_Color)220);
            o->selection_color(FL_SELECTION_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(12);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(255);
            o->step(1);
            o->textsize(10);
            o->textcolor(7);
            o->callback((Fl_Callback*)cb_namedblue);
            o->align(FL_ALIGN_LEFT);
            o->when(FL_WHEN_CHANGED);
          }
          { Fl_Check_Button* o = namedalpha = new Fl_Check_Button(359, 191, 68, 17, "keep alpha");
            o->down_box(FL_DOWN_BOX);
            o->labelsize(10);
            o->callback((Fl_Callback*)cb_namedalpha);
          }
          o->end();
          Fl_Group::current()->resizable(o);
        }
        o->end();
        Fl_Group::current()->resizable(o);
      }
      o->end();
      Fl_Group::current()->resizable(o);
    }
    o->end();
  }
  activecolorbutton=lcolor;
lcolor->box(FL_THIN_DOWN_FRAME);
updateColorChooser(currgrad,colorval->current_segment());
Fl::focus(colorval);
  { Fl_Double_Window* o = about_window = new Fl_Double_Window(279, 211, "ExoCap - Full Body MOCAP");
    w = o;
    o->color((Fl_Color)19);
    o->callback((Fl_Callback*)cb_about_window);
    { Fl_Box* o = new Fl_Box(7, 8, 266, 199);
      o->box(FL_RSHADOW_BOX);
      o->color((Fl_Color)19);
    }
    { Fl_Box* o = new Fl_Box(20, 17, 42, 36, "Y");
      o->labeltype(FL_SHADOW_LABEL);
      o->labelfont(11);
      o->labelsize(48);
      o->labelcolor((Fl_Color)3);
    }
    { Fl_Box* o = new Fl_Box(17, 69, 221, 30, "Yet Another Gradient Editor");
      o->color((Fl_Color)55);
      o->labelcolor((Fl_Color)55);
      o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    }
    { Fl_Box* o = new Fl_Box(39, 100, 183, 39, "\251 2003,2004 By Daniel Barrero\nhttp://dbarrero.tripod.com");
      o->box(FL_BORDER_BOX);
      o->color((Fl_Color)19);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
    }
    { Fl_Return_Button* o = new Fl_Return_Button(196, 178, 71, 25, "OK");
      o->box(FL_ROUND_UP_BOX);
      o->color((Fl_Color)51);
      o->callback((Fl_Callback*)cb_OK);
    }
    { Fl_Box* o = new Fl_Box(55, 30, 42, 36, "A");
      o->labeltype(FL_SHADOW_LABEL);
      o->labelfont(11);
      o->labelsize(48);
      o->labelcolor((Fl_Color)17);
    }
    { Fl_Box* o = new Fl_Box(93, 13, 42, 36, "G");
      o->labeltype(FL_SHADOW_LABEL);
      o->labelfont(11);
      o->labelsize(48);
      o->labelcolor((Fl_Color)6);
    }
    { Fl_Box* o = new Fl_Box(128, 29, 43, 37, "E");
      o->labeltype(FL_SHADOW_LABEL);
      o->labelfont(11);
      o->labelsize(48);
      o->labelcolor((Fl_Color)2);
    }
    { Fl_Box* o = new Fl_Box(173, 47, 53, 32, "V. 0.1");
      o->color((Fl_Color)51);
      o->labeltype(FL_SHADOW_LABEL);
      o->labelsize(22);
      o->labelcolor((Fl_Color)55);
    }
    { Fl_Box* o = new Fl_Box(18, 144, 232, 31, "GUI based in part on the excelent work of the FLTK proyect (http://www.fltk.o\
rg)");
      o->color(FL_LIGHT2);
      o->labelsize(10);
      o->labelcolor((Fl_Color)35);
      o->align(FL_ALIGN_WRAP);
    }
    o->set_modal();
    o->end();
  }
  { Fl_Double_Window* o = manual_window = new Fl_Double_Window(289, 115, "ExoCap-Manual");
    w = o;
    o->labelsize(12);
    o->callback((Fl_Callback*)cb_manual_window);
    { Fl_Box* o = new Fl_Box(17, 24, 256, 52, "Gradient editing Keybindings:\nINS  - split the current segment in two\nDEL -\
 delete the current segment");
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    }
    { Fl_Return_Button* o = new Fl_Return_Button(210, 82, 71, 25, "OK");
      o->box(FL_ROUND_UP_BOX);
      o->color((Fl_Color)51);
      o->callback((Fl_Callback*)cb_OK1);
    }
    o->set_modal();
    o->end();
  }
  return w;
}
